      subroutine authenticate(serialnumber,authcode,compiler,licversion,
     *   license,edate,users,comptype,nummany,manyusers,status)
 
c     Subroutine to check whether serial number and authentication
c     code match.  Arguments:
c
c     serialnumber  [in] 8-character serial number
c     authcode      [in] 8-character authorization code
c     compiler     [out] 1-digit compiler
c     licversion   [out] 2-digit license version
c     license      [out] 1-digit license type
c     edate        [out] elapsed date on which serial number was generated
c     users        [out] number of users on this license (may be >1,000,000)
c     comptype      [in] character*1 array with compiler codes
c     status       [out] 0 = serial and authorization codes match
c                        1 = serial and authorization codes do not match
c
c     Constantijn Panis, 18 April 2001
c     Last change: Allow for Red Hat Linux g77
 
      implicit none
      integer status,compiler,licversion,license,number,edate,
     *   users,nummany,manyusers(nummany),temp,tmp1,month,day,year
      character serialnumber*8,authcode*8,comptype(5)*1,str33*33
      data str33/'bv75n0gzajmptcse82h361w4yxqf9rudk'/
 
      status=0
      call lowercase(authcode,authcode)
 
c     Unravel authentication code into:
c        compiler    1
c        licversion  2
c        license     1
c        number      2
c        edate       4
c        users       2
      call char1match(authcode(1:1),str33,33,tmp1)
      temp=tmp1-1
      call char1match(authcode(2:2),str33,33,tmp1)
      temp=33*temp+tmp1-1
      call char1match(authcode(3:3),str33,33,tmp1)
      temp=33*temp+tmp1-1
      call char1match(authcode(4:4),str33,33,tmp1)
      temp=33*temp+tmp1-1
 
      compiler=10-temp/100000
      temp=mod(temp,100000)
      licversion=100-temp/1000
      temp=mod(temp,1000)
      license=10-temp/100
      temp=mod(temp,100)
      number=100-temp
 
      call char1match(authcode(5:5),str33,33,tmp1)
      temp=tmp1-1
      call char1match(authcode(6:6),str33,33,tmp1)
      temp=33*temp+tmp1-1
      call char1match(authcode(7:7),str33,33,tmp1)
      temp=33*temp+tmp1-1
      call char1match(authcode(8:8),str33,33,tmp1)
      temp=33*temp+tmp1-1
 
c     Users is coded 0-99 here, decoded below.
      users=100-temp/10000
      temp=mod(temp,10000)
      edate=10000-temp
 
      if(mod(users,10).eq.1)then
         number=100*(users/10)+number
         users=1
      endif
 
c     Check whether this matches the serial number
      if(compiler.le.0.or.compiler.gt.5)goto 800
      if(serialnumber(1:1).ne.comptype(compiler))goto 800
 
      call mdytoe(1,1,1999,temp)
      call etomdy(edate+temp,month,day,year)
      call c2i(serialnumber(2:3),temp,status)
      if(status.ne.0)goto 800
      if(12*(year-1999)+month-1.ne.temp)goto 800
 
      call c2i(serialnumber(4:4),temp,status)
      if(status.ne.0)goto 800
      if(temp.ne.license)goto 800
 
      call c2i(serialnumber(5:6),temp,status)
      if(status.ne.0)goto 800
      if(mod(temp,10).eq.1)temp=1
      if(temp.ne.users)goto 800
 
      if(users.eq.1)then
         call c2i(serialnumber(5:5)//serialnumber(7:8),temp,status)
      else
         call c2i(serialnumber(7:8),temp,status)
      endif
      if(status.ne.0)goto 800
      if(temp.ne.number)goto 800
 
c     Decode users, may still be >1,000,000
      if(users.gt.50+nummany)goto 800
      if(users.gt.50)users=manyusers(users-50)
 
      goto 999
 
  800 status=1
  999 return
      end
 
