      subroutine compstats(numstats,stats)
 
c     Subroutine to compute statistics on double precision
c     variables.  Argument:
c        stats(1) = number of observations
c        stats(2) = [in] sum             [out] mean
c        stats(3) = [in] sum of squares  [out] standard deviation
c        stats(4) = minimum
c        stats(5) = maximum
c
c     These statistics were gathered by subroutine figstats.
c
c     Constantijn Panis,  16 July 1999
c     Last change: standard deviation based on (n-1) instead of n.
 
      implicit none
      integer numstats,i
      double precision stats(5,numstats),n,mean,var
      var=0.d0
 
      do 100 i=1,numstats
         if(stats(1,i).eq.0.d0)goto 100
 
         n=stats(1,i)
         mean=stats(2,i)/n
         if(n.ne.1.d0)var=(stats(3,i)/n-mean*mean)*n/(n-1.d0)
 
         stats(2,i) = mean
         if(n.eq.1.d0.or.var.le.0.d0.or.stats(4,i).eq.stats(5,i))then
            stats(3,i)=0.d0
         else
            stats(3,i)=dsqrt(var)
         endif
  100 continue
 
      return
      end
 
