      subroutine compxb(task,numterm,thisterm,nx,np,nptotal,
     *   beta,par,xb1,xb2,dbeta,dpar,dxb,x)
 
c     Subroutine to compute a regressor set and to unravel derivatives.
c
c     Constantijn Panis, 6 April 1996
 
      implicit none
      integer task,numterm,thisterm,nx,np,nptotal,i,j,num
      double precision beta(nx),par,xb1(np),
     *   xb2(nptotal,numterm),dbeta(nx),dpar,dxb(np),
     *   temp,dpvecsum,innerp84
      real x(nx,np)
 
c     Compute XBeta/par or unravel derivatives?
      if(task.eq.1)goto 100
      if(task.eq.2)goto 200
      if(task.eq.3)goto 300
      if(task.eq.4)goto 400
      call bug(1,1)
 
c     Compute and assign XBeta:
  100 do 110 i=1,np
         xb1(i) = innerp84(beta,x(1,i),nx)
  110 continue
      goto 999
 
c     Unravel derivatives from multiplied XB (accumulate, don't assign):
  200 if(numterm.eq.1)then
c        Simple: derivative is derivative wrt XB times X:
         do 210 i=1,np
            do 215 j=1,nx
               dbeta(j) = dbeta(j) + dxb(i)*dble(x(j,i))
  215       continue
  210    continue
      else
c        Harder: xb consists of multiple terms:
         do 220 i=1,np
            temp = dxb(i)
            do 230 num=1,numterm
               if(num.ne.thisterm)temp = temp*xb2(i,num)
  230       continue
            do 240 j=1,nx
               dbeta(j) = dbeta(j) + temp*dble(x(j,i))
  240       continue
  220    continue
      endif
      goto 999
 
c     Assign parameter to xb as if it were a regressor set:
  300 call put(par,xb1,np)
      goto 999
 
c     Unravel dxb wrt parameter.
  400 if(numterm.eq.1)then
c        The regressor set was a parameter only:
         dpar = dpar + dpvecsum(dxb,np)
      else
c        Harder: parameter is part of interaction with numterm terms:
         do 420 i=1,np
            temp = dxb(i)
            do 430 num=1,numterm
               if(num.ne.thisterm)temp = temp*xb2(i,num)
  430       continue
            dpar = dpar + temp
  420    continue
      endif
      goto 999
 
  999 return
      end
