      double precision function dfactorial(n)
 
c     Double precision (!) function to compute n! using the gamma
c     function.  The integer representation of n! is only correct for
c     n<=12.  Double precision will not overflow for n<=170.
c     The maximum relative error between 1*2*3*...*n (all in double
c     precision) and dfactorial(n) is 1.296d-13.
c
c     Note the existence of factorial, which computes the integer
c     factorial of n, n<=12.
c
c     Constantijn Panis,  3 February 1992
 
      implicit none
      double precision dlgama
      integer n
 
      dfactorial = dexp(dlgama(dble(n+1)))
 
      return
      end
