      integer function dlen(x)
 
c     Integer function to determine the number of spaces that writing the
c     integer-truncated portion of a double precision number would require.
c     This function is particularly useful in format statements.
c
c     Example:
c     n=dlen(x)+3
c     write(*,1)x
c   1 format(.......,f<n>.2,.....)
c
c     This format statement requires an extension to Fortran 77.
c
c     Note: rounding problem occurs in Red Hat Linux GNU g77.
c     For example, dlog10(dble(10)) - 1 = -2.nnnE-17.
c
c     Constantijn Panis,  21 April 2001
c     Last change: account for g77
 
      implicit none
      double precision x
 
      if(x.le.-1.d0)then
         dlen = int(dlog10(dint(-x)+.5d0)) + 2
      elseif(x.lt.0.d0)then
         dlen = 2
      elseif(x.eq.0.d0)then
         dlen = 1
      elseif(x.lt.1.d0)then
         dlen = 1
      else
         dlen = int(dlog10(dint(x)+.5d0)) + 1
      endif
 
c     If x was NaN, dlen may screw up.
      dlen = max(1,dlen)
 
      return
      end
