      real function endexprs()
 
c     Real function to return the internal representation of endexprs
c     the number which is used by readexpr to denote that the next
c     term is the end of an expression (or the last expression in a
c     series of multiple expressions).  Endexprs is the real equivalent
c     of 10,000,005, i.e., about
c
c     Note: an earlier version set endexprs=realequiv(9,999,999).
c     Also see varnext, opernext, enditem, endexpr, and endexprs.
c
c     The following special numbers are in use:
c                     integer         real        hexadecimal:
c        varnext     10,000,001    1.40130E-38      00989681
c        opernext    10,000,002    1.40130E-38      00989682
c        enditem     10,000,003    1.40130E-38      00989683
c        endexpr     10,000,004    1.40130E-38      00989684
c        endexprs    10,000,005    1.40130E-38      00989685
c
c     Constantijn Panis, 15 November 2000
c     Last change: 10,000,005 instead of 9,999,999.
 
      implicit none
      integer i
      real x
      equivalence(i,x)
      data i/10000005/
 
      endexprs=x
 
      return
      end
 
 
