      subroutine fdfd2f(dim,theta,f,if1,d1theta,if2,d2theta)
 
c     Subroutine to compute a function value based on a vector of parameters,
c     its analytical first derivatives, and analytical second derivatives.
c
c     Constantijn Panis, 24 January 1996
 
      implicit none
      integer dim,i,j
      double precision theta(dim),f,d1theta(dim),d2theta(dim,dim)
      logical if1,if2
 
      f=0.d0
      do 100 i=2,dim
         f=f+i*theta(i-1)*theta(i)
  100 continue
 
      if(if1)then
c        First derivatives:
         call zerodp(dim,d1theta)
         do 200 i=2,dim
            d1theta(i-1)=d1theta(i-1)+i*theta(i)
            d1theta(i)=d1theta(i)+i*theta(i-1)
  200    continue
      endif
 
      if(if2)then
c        Second derivatives:
         call zerodp(dim*dim,d2theta)
         do 300 i=1,dim
            do 310 j=1,dim
               if(abs(i-j).eq.1)d2theta(i,j)=max(i,j)
  310       continue
  300    continue
      endif
 
      return
      end
