      subroutine figdata72(levelmax,nbdim,nb,nb2,nummodel,moelpntr,
     *   xdim,vdim,maxxnode,struc,modeltype,mdllvl,strctre,vdimmax,
     *   nep,nnemp,neint,maxmeno,moel,maxnmapmoel,mapmoel,datas,
     *   minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,
     *   distdim,maxdraws,draws,draw,ndraw,dimused,distyp,lamtyp,lamrow,
     *   sparsity,distpos,dimxpntr,xpntr,nfull,fulltype,maxref,
     *   parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *   numspl,beginspl,nodepos,numnodes,spltype,splref,datadim,
     *   rspmax,maxfreqcat,nfreq,maxnfreq,branch,prevbranch,freqloc,
     *   freqcat,freqs,namepntr,nxold,nold,originstats,
     *   rsetstats,x,v,xnode,distvar,oldname,ifint4,
     *   iflam,detail,check99999,splname,resname,iobs,id,ipt,jpt)
 
c     Subroutine to figure out exactly which regressors et cetera
c     enter multinomial probit models.
c
c     Constantijn Panis,  27 March 2003
c     Last change: let ie count probit module, including simple/ordered
c     probits processed by figdata4.
 
      implicit none
      integer levelmax,nbdim,nb(nbdim,2),nb2,nummodel,
     *   moelpntr(nummodel),nep,nnemp,neint,xdim,vdim,
     *   maxxnode,numdist,sumdim,
     *   intpnts(sumdim),struc(nb2),modeltype(nummodel),
     *   mdllvl(nummodel),strctre(nummodel),
     *   vdimmax,meno,maxmeno,moel(maxmeno),nmapmoel,plusmin,
     *   maxnmapmoel,mapmoel(maxnmapmoel),datas(nummodel),
     *   minlnl(nummodel),distdim(numdist),
     *   maxdraws,draws(maxdraws,numdist),draw(numdist,nep+nnemp),
     *   ndraw(numdist),dimused(sumdim),
     *   distyp(numdist),lamtyp(numdist),lamrow(numdist),sparsity,
     *   distpos(numdist),dimxpntr,xpntr(2:dimxpntr,nb2),
     *   nfull,fulltype(nfull),maxref,parref(maxref),rs,rspmax,
     *   rsetref(maxref),resref(maxref),numpar,parpos(numpar),numrset,
     *   rsetbegin(numrset),rsetnum(numrset),
     *   numspl,beginspl(numspl),nodepos(numspl),numnodes(numspl)
      integer spltype(numspl),splref(maxref),datadim,
     *   namepntr(levelmax,datadim),nxold(levelmax,datadim),maxfreqcat,
     *   nold,nfreq(nummodel),maxnfreq,freqloc(maxnfreq),
     *   branch(levelmax),prevbranch(levelmax),branchnum,
     *   freqs(maxfreqcat,maxnfreq),ifint4(numdist),ds,m,ib2,ie,
     *   select,status,num,pos,iobs,id,ipt,jpt,
     *   neqn,eqn,match,resdone,trm,intmax
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),xnode(maxxnode),outcome,
     *   freqcat(maxfreqcat,maxnfreq),realinf
      character distvar(numdist)*8,oldname(*)*8,splname(numspl)*12,
     *   resname(sumdim)*8,string*60,idstring*60
      logical iflam(numdist),detail,check99999
 
c     ie counts the module number.  Since this routine converts multinomial
c     probits into simple probits, the numbering should continue from
c     (ordered) probits processed in figdata4.
      ie=nep
 
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
      do 100 m=1,nummodel
c        Is it a continuous model?
         if(modeltype(m).ne.72)goto 100
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
         neqn=moel(moelpntr(m)+1)
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
         call putint(intmax(),prevbranch,levelmax)
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
c        Outcome:
         call evalexpr(1,maxxnode,xdim,moel(moelpntr(m)+2),nold,
     *      levelmax,mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *      namepntr(1,ds),xnode,x,outcome,oldname,struc(ib2),
     *      iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
c        Outcome is the value of the outcome variable (expression).
c        Determine its corresponding equation number.
         call intmatch(int(outcome),moel(moelpntr(m)+3),neqn,match)
 
c        Loop over alternatives.
         eqn=0
  130    eqn=eqn+1
 
c        Check in ithobs:
         vdim=vdim+1
         ie=ie+1
         neint=-abs(neint)
         v(vdim)=real(ie)
 
c        Convert each multinomial probit outcome into neqn simple probits.
c        In the scratch data, each probit generates two positions for the
c        outcome (-Inf,0) or (0,Inf), see figure_tau with termtype=-64,
c        followed by RHS specification.
c        If match=0, outcome is omitted category.
c
c        Multinomial probit with neqn=3:
c           match=0:  U1<U0    u1    <-XB1      outcome=0  model=1
c                     U2<U0    u2    <-XB2      outcome=0  model=2
c                     U3<U0    u3    <-XB3      outcome=0  model=3
c           match=1:  U0<U1    u1    < XB1      outcome=1  model=1
c                     U2<U1    u2-u1 < XB1-XB2  outcome=0  model=2-1
c                     U3<U1    u3-u1 < XB1-XB3  outcome=0  model=3-1
c           match=2:  U0<U2    u2    < XB2      outcome=1  model=2
c                     U1<U2    u1-u2 < XB2-XB1  outcome=0  model=1-2
c                     U3<U2    u3-u2 < XB2-XB3  outcome=0  model=3-2
c           match=3:  U0<U3    u3    < XB3      outcome=1  model=3
c                     U1<U3    u1-u3 < XB3-XB1  outcome=0  model=1-3
c                     U2<U3    u2-u3 < XB3-XB2  outcome=0  model=2-3
c
c        There are as many simple probits as there are equations.  Their
c        outcomes follow figure_tau with termtype=-64.  Their RHS specifications
c        follow own equations' RHS specifications, minus outcome specification
c        (unless outcome omitted category, match=0).
         nmapmoel=nmapmoel+1
         mapmoel(nmapmoel)=-62
         if(match.eq.eqn)then
c           Outcome is always one:
            v(vdim+1)=0.
            v(vdim+2)=realinf()
         else
c           Outcome is always zero:
            v(vdim+1)=-realinf()
            v(vdim+2)=0.
         endif
         vdim=vdim+2
 
c        Set up regressor sets and residual structures.  Moel contains:
c           1 = keep/drop (pointer to xnode)
c           2 = number of equations (=number of choices-1)
c           3 = outcome (pointer to xnode)
c           4 = potential outcome 1
c           5 = potential outcome 2
c           ++  et cetera
c           4+neqn  pointer to model specification for first outcome (=4+2*neqn)
c           5+neqn  pointer to model specification for second outcome
c           ++  et cetera
c           4+2*neqn  model specification, first equation
c           ++  model specification, next equation,
c           ++  etc.
         meno=moel(moelpntr(m)+neqn+2+eqn)
         rs=0
         resdone=0
c        Careful: figdata must be called with ie equal to probit module
c        including modules processed by figdata4, because figure_res needs
c        to compare it to draws for all probit modules to determine sparsity
c        of load matrices.
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),7,mdllvl(m),mdllvl(m),1,vdimmax,
     *      neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *      numdist,sumdim,intpnts,distdim,maxdraws,draws,
     *      draw(1,ie),ndraw,dimused,distyp,lamtyp,lamrow,sparsity,
     *      distpos,xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,
     *      rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,splref,
     *      0,0,0,rs,rspmax,rs,rspmax,-1,-1,resdone,-1,branch,
     *      namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *      x,v,0.,xnode,0.,0.,distvar,oldname,iflam,
     *      detail,check99999,splname,resname,0,ie,ifint4,
     *      iobs,id,ipt,jpt)
 
         if(match.ne.0.and.match.ne.eqn)then
c           Subtract RHS of equation match:
            if(mapmoel(nmapmoel).ne.-99)call bug(ipt,jpt)
            nmapmoel=nmapmoel-1
            meno=moel(moelpntr(m)+neqn+2+match)
c           See above caveat about ie being total probit module number.
            call figdata(-1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *         struc(ib2),modeltype(m),7,mdllvl(m),mdllvl(m),1,vdimmax,
     *         neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *         numdist,sumdim,intpnts,distdim,maxdraws,draws,
     *         draw(1,ie),ndraw,dimused,distyp,lamtyp,lamrow,sparsity,
     *         distpos,xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,
     *         parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,
     *         rsetnum,numspl,beginspl,nodepos,numnodes,spltype,splref,
     *         0,0,0,rs,rspmax,rs,rspmax,-1,-1,resdone,-1,branch,
     *         namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *         x,v,0.,xnode,0.,0.,distvar,oldname,iflam,
     *         detail,check99999,splname,resname,0,ie,ifint4,
     *         iobs,id,ipt,jpt)
         endif
         if(resdone.eq.0)goto 800
 
         if(detail)then
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
c           Keep track of outcome (only once, not neqn times):
            if(eqn.eq.1.and.num.gt.0)call figure_freq(outcome,
     *         freqcat(1,pos),freqs(1,pos),maxfreqcat)
            num=num-1
            pos=pos+1
c           Keep track of other variables:
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
c        Go to next alternative:
         if(eqn.lt.neqn)goto 130
 
c        Go to next outcome:
         goto 120
  100 continue
      if(ie.ne.nep+nnemp)call bug(ipt,jpt)
      goto 999
 
  800 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  there is no '//
     *   'non-integrated residual in a multinomial probit model ('//
     *   string(1:trm(string))//').')
      if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  there is no '//
     *   'non-integrated residual in a multinomial probit model ('//
     *   string(1:trm(string))//').')
      stop
 
  999 return
      end
 
