      subroutine figstats(stats,x)
 
c     Subroutine to keep trackof summary statistics of a double
c     precision variable.  Statistics are kept in stats:
c        stats(1) = number of observations on x
c        stats(2) = sum(x)    (for mean)
c        stats(3) = sum(x*x)  (for variance)
c        stats(4) = min(x)
c        stats(5) = max(x)
c
c     The sum will be converted into a mean, the sum of squares into
c     a standard deviation by subroutine compstats.
c
c     Constantijn Panis, 22 June 1993
 
      implicit none
      double precision stats(5),x
 
      if(stats(1).eq.0.d0)then
         stats(1)=1.d0
         stats(2)=x
         stats(3)=x*x
         stats(4)=x
         stats(5)=x
      else
         stats(1)=stats(1)+1.d0
         stats(2)=stats(2)+x
         stats(3)=stats(3)+x*x
         stats(4)=min(stats(4),x)
         stats(5)=max(stats(5),x)
      endif
 
      return
      end
