      subroutine figure_data(levelmax,nb2,nbdim,nb,ne,neh,nel,nep,nec,
     *   neb,nen,nepo,neml,nemp,nnemp,neint,numdist,sumdim,distdim,
     *   intpnts,dimused,maxdraws,draws,draw,ndraw,distyp,lamtyp,lamrow,
     *   sparsity,distpos,datadim,vdimmax,maxnfreq,nummodel,maxmeno,
     *   maxnmapmoel,nmapmoel,plusmin,mp1,mp4,mp6,mp5,mp7,numrset,
     *   numpar,maxref,maxfreqcat,maxxnode,xdim,
     *   vdim,vpntr1,vpntr4,vpntr6,vpntr5,vpntr7,struc,xpntr,
     *   moel,mdllvl,moelpntr,mapmoel,datas,minlnl,strctre,
     *   namepntr,nxold,nold,modeltype,rsetbegin,rsetnum,parref,
     *   rsetref,resref,parpos,pardim,nfreq,freqloc,freqcat,freqs,
     *   branch,prevbranch,iobs,id,ipt,jpt,originstats,
     *   rsetstats,x,v,xnode,splname,oldname,resname,parname,
     *   distvar,nfull,fulltype,iiffull,iflam,
     *   detail,check99999,ifint4,ifint6,numspl,
     *   maxmspl,splref,beginspl,nodepos,numnodes,spltype,maxnode,
     *   maxds,nngammax,rsh3max,rsh4max,rsh5max,splineorigin,rspmax,
     *   iftau,numarma,rscmax,rsnamax,rsnpmax,rsmlmax)
 
c     Subroutine to figure out exactly which model elements enter all
c     outcomes, and to create a scratch data set.
c     This routine applies to one observation.
c
c     Note:  if numdist=0, draw(1,..) references are out of bounds.
c     This is harmless, but in this routine array bounds should not
c     be checked.
c
c     Constantijn Panis, 10 November 2002
c     Last change: Poisson
 
      implicit none
      integer levelmax,nb2,nbdim,nb(nbdim,2),ne,neh,nel,nep,nec,neb,nen,
     *   nepo,neml,nemp,nnemp,neint,numdist,sumdim,numspl,
     *   dimused(sumdim),intpnts(sumdim),distdim(numdist),
     *   ifint4(numdist),ifint6(numdist),maxdraws,
     *   draws(maxdraws,numdist),draw(numdist,ne),ndraw(numdist),
     *   distyp(numdist),lamtyp(numdist,8),lamrow(numdist,8),sparsity,
     *   distpos(numdist),
     *   datadim,vdimmax,maxnfreq,nummodel,maxmeno,maxnmapmoel,nmapmoel,
     *   plusmin,mp1,mp4,mp6,mp5,mp7,numrset,numpar,maxref,maxfreqcat,
     *   maxxnode,xdim,vdim,vpntr1,vpntr4,vpntr6,vpntr5,vpntr7,
     *   struc(nb2),xpntr(2:levelmax,nb2),moel(maxmeno),
     *   mdllvl(nummodel),moelpntr(nummodel),mapmoel(maxnmapmoel),
     *   datas(nummodel),minlnl(nummodel),freqs(maxfreqcat,maxnfreq)
      integer nfull,fulltype(nfull),iiffull(nfull),
     *   strctre(nummodel),nold,
     *   nxold(levelmax,datadim),namepntr(levelmax,datadim),
     *   modeltype(nummodel),rsetbegin(numrset),rsetnum(numrset),
     *   parref(maxref),rsetref(maxref),
     *   resref(maxref),parpos(numpar),pardim(numpar),
     *   nfreq(nummodel),freqloc(maxnfreq),
     *   branch(levelmax),prevbranch(levelmax),
     *   i,iobs,id,ipt,jpt
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),xnode(maxxnode),
     *   freqcat(maxfreqcat,maxnfreq)
      character splname(numspl)*12,parname(numpar)*12,
     *   oldname(*)*8,resname(sumdim)*8,distvar(numdist)*8
      logical iflam(numdist),detail,check99999
      integer maxmspl,splref(maxref),
     *   beginspl(numspl),nodepos(numspl),numnodes(numspl),
     *   spltype(numspl),maxnode,maxds,nngammax,rsh3max,rsh4max,
     *   rsh5max
      real splineorigin(maxmspl)
      logical iftau
      integer numarma,rspmax,rscmax,rsnamax,rsnpmax,rsmlmax,dimxpntr
 
c     General initializations:
      call zeroint(sumdim,dimused)
      call zeroint(maxdraws*numdist,draws)
      call zeroint(numdist*ne,draw)
      call zeroint(numdist,ndraw)
      vdim=0
      nmapmoel=0
      neint=0
      branch(1)=1
c     Initialize Lambda types.  There are potentially numdist*8 Lambdas,
c     i.e., numdist for (1) hazard, (2) probit, (3) logit, (4) continuous,
c     (5) binomial, (6) negative binomial models, (7) Poisson, and
c     (8) multinomial logit models.  If a Lambda is the identity matrix,
c     much efficiency may be gained.
c     Lamtyp =-1 if there is no Lambda, i.e., this distribution is not
c                used by this model type.  (Also exploited in setting
c                Lambda dimensions, in figure_pos.)
c              0 if Lambda is generic (no efficiency gain possible).
c              1 if Lambda is identity
c              2 if Lambda is symmetric (irrelevant)
c              3 if Lambda is symmetric and block-diagonal (irrelevant)
c              4 if Lambda is sparse.
c     See figure_res for the ultimate determination; matrix type is
c     exploited in ithobs.  (For each distribution, lamtyp is summarized
c     into a scalar just before write_scr and untransformed just after
c     read_scr, in codelamtyp.)
      call putint(-1,lamtyp,8*numdist)
      call putint(0,lamrow,8*numdist)
 
c     The dimension of xpntr is xpntr(2:levelmax,nb2).  Even without bound
c     checking, the debug version aborts every time xpntr(2,ib2) is called
c     in figdata* with levelmax=0.  Prevent this:
      dimxpntr=max(2,levelmax)
 
c     Hazard model elements:
      vpntr1=1
      mp1=1
      if(neh.gt.0)call figdata1(levelmax,nb2,nbdim,datadim,neh,neint,
     *   nfull,nold,maxmspl,vdimmax,maxnfreq,nummodel,numspl,maxref,
     *   numpar,maxmeno,maxnmapmoel,numdist,sumdim,maxdraws,draws,
     *   draw(1,1),ndraw,numrset,maxnode,maxds,nngammax,rsh3max,
     *   rsh4max,rsh5max,maxxnode,maxfreqcat,xdim,vdim,nmapmoel,plusmin,
     *   ipt,jpt,iobs,id,nb,branch,struc,dimxpntr,xpntr,nxold,namepntr,
     *   fulltype,moel,moelpntr,mapmoel,datas,minlnl,modeltype,mdllvl,
     *   strctre,intpnts,dimused,distdim,distyp,lamtyp(1,1),
     *   lamrow(1,1),sparsity,distpos,rsetbegin,rsetnum,beginspl,
     *   nodepos,numnodes,spltype,parpos,parref,rsetref,resref,splref,
     *   nfreq,freqloc,freqcat,freqs,originstats,rsetstats,x,
     *   v,splineorigin,xnode,iflam,detail,check99999,splname,
     *   resname,oldname)
 
c     Logit model elements:
      vpntr4=vdim+1
      mp4=nmapmoel+1
      if(nel.gt.0)call figdata4(levelmax,nbdim,nb,nb2,nel,neint,nfull,
     *   maxxnode,datadim,
     *   nummodel,mdllvl,maxmeno,maxnmapmoel,numpar,numrset,numspl,
     *   numdist,sumdim,maxdraws,draws,draw(1,neh+1),ndraw,dimused,
     *   maxfreqcat,maxnfreq,moel,mapmoel,datas,minlnl,nmapmoel,plusmin,
     *   distdim,intpnts,distyp,lamtyp(1,2),lamrow(1,2),sparsity,
     *   distpos,moelpntr,maxref,struc,dimxpntr,xpntr,modeltype,branch,
     *   namepntr,nxold,nold,strctre,rsetbegin,rsetnum,resref,
     *   rsetref,beginspl,nodepos,numnodes,spltype,splref,parref,pardim,
     *   parpos,nfreq,freqloc,freqcat,freqs,rspmax,
     *   xdim,vdim,vdimmax,originstats,rsetstats,x,v,xnode,
     *   fulltype,iiffull,ifint4,iftau,iflam,detail,check99999,.true.,
     *   resname,oldname,parname,splname,iobs,id,ipt,jpt)
 
c     Probit model elements:
      if(nep.gt.0)call figdata4(levelmax,nbdim,nb,nb2,nep,neint,nfull,
     *   maxxnode,datadim,
     *   nummodel,mdllvl,maxmeno,maxnmapmoel,numpar,numrset,numspl,
     *   numdist,sumdim,maxdraws,draws,draw(1,neh+nel+1),ndraw,dimused,
     *   maxfreqcat,maxnfreq,moel,mapmoel,datas,minlnl,nmapmoel,plusmin,
     *   distdim,intpnts,distyp,lamtyp(1,3),lamrow(1,3),sparsity,
     *   distpos,moelpntr,maxref,struc,dimxpntr,xpntr,modeltype,branch,
     *   namepntr,nxold,nold,strctre,rsetbegin,rsetnum,resref,
     *   rsetref,beginspl,nodepos,numnodes,spltype,splref,parref,pardim,
     *   parpos,nfreq,freqloc,freqcat,freqs,rspmax,
     *   xdim,vdim,vdimmax,originstats,rsetstats,x,v,xnode,
     *   fulltype,iiffull,ifint4,iftau,iflam,detail,check99999,.false.,
     *   resname,oldname,parname,splname,iobs,id,ipt,jpt)
 
c     Multinomial probit elements (convert into simple probits):
      if(nemp.gt.0)call figdata72(levelmax,nbdim,nb,nb2,nummodel,
     *   moelpntr,xdim,vdim,maxxnode,struc,modeltype,mdllvl,strctre,
     *   vdimmax,nep,nnemp,neint,maxmeno,moel,maxnmapmoel,mapmoel,
     *   datas,minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,distdim,
     *   maxdraws,draws,draw(1,neh+nel+nep+1),ndraw,dimused,
     *   distyp,lamtyp(1,3),lamrow(1,3),
     *   sparsity,distpos,dimxpntr,xpntr,nfull,fulltype,maxref,
     *   parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *   numspl,beginspl,nodepos,numnodes,spltype,splref,datadim,
     *   rspmax,maxfreqcat,nfreq,maxnfreq,branch,prevbranch,freqloc,
     *   freqcat,freqs,namepntr,nxold,nold,originstats,
     *   rsetstats,x,v,xnode,distvar,oldname,ifint4,iflam,detail,
     *   check99999,splname,resname,iobs,id,ipt,jpt)
      nep=nep+nnemp
 
c     Continuous model elements:
      vpntr6=vdim+1
      mp6=nmapmoel+1
      if(nec.gt.0)call figdata6(levelmax,nbdim,nb,nb2,nummodel,moelpntr,
     *   xdim,vpntr6,vdim,maxxnode,struc,modeltype,mdllvl,strctre,
     *   vdimmax,nec,neint,maxmeno,moel,maxnmapmoel,mapmoel,datas,
     *   minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,distdim,
     *   maxdraws,draws,draw(1,neh+nel+nep+1),ndraw,dimused,distyp,
     *   lamtyp(1,4),lamrow(1,4),sparsity,distpos,numarma,dimxpntr,
     *   xpntr,nfull,fulltype,maxref,parref,rsetref,resref,numpar,
     *   parpos,numrset,rsetbegin,rsetnum,numspl,beginspl,nodepos,
     *   numnodes,spltype,splref,datadim,rscmax,maxfreqcat,nfreq,
     *   maxnfreq,branch,prevbranch,freqloc,freqcat,freqs,namepntr,
     *   nxold,nold,originstats,rsetstats,x,v,xnode,distvar,oldname,
     *   ifint6,iflam,detail,check99999,splname,resname,iobs,id,ipt,jpt)
 
c     Binomial model elements:
      vpntr5=vdim+1
      mp5=nmapmoel+1
      if(neb.gt.0)call figdata5(levelmax,nbdim,nb,nb2,neb,neint,
     *   datadim,nummodel,vdimmax,numrset,numspl,maxref,numpar,nold,
     *   nfull,numdist,sumdim,maxdraws,distdim,distyp,lamtyp(1,5),
     *   lamrow(1,5),sparsity,distpos,dimused,intpnts,fulltype,ndraw,
     *   draws,draw(1,neh+nel+nep+nec+1),maxxnode,
     *   maxmeno,maxnmapmoel,maxnfreq,maxfreqcat,51,modeltype,mdllvl,
     *   strctre,moel,moelpntr,mapmoel,datas,minlnl,nmapmoel,
     *   plusmin,struc,dimxpntr,xpntr,namepntr,nxold,rsetbegin,
     *   rsetnum,parref,rsetref,splref,resref,beginspl,nodepos,
     *   numnodes,spltype,nfreq,freqloc,freqcat,freqs,parpos,branch,
     *   rsnamax,rsnpmax,xdim,vdim,iobs,id,ipt,jpt,originstats,
     *   rsetstats,xnode,x,v,iflam,detail,check99999,
     *   resname,oldname,splname)
 
c     Negative binomial model elements:
      if(nen.gt.0)call figdata5(levelmax,nbdim,nb,nb2,nen,neint,
     *   datadim,nummodel,vdimmax,numrset,numspl,maxref,numpar,nold,
     *   nfull,numdist,sumdim,maxdraws,distdim,distyp,lamtyp(1,6),
     *   lamrow(1,6),sparsity,distpos,dimused,intpnts,
     *   fulltype,ndraw,draws,draw(1,neh+nel+nep+nec+neb+1),maxxnode,
     *   maxmeno,maxnmapmoel,maxnfreq,maxfreqcat,57,modeltype,mdllvl,
     *   strctre,moel,moelpntr,mapmoel,datas,minlnl,nmapmoel,
     *   plusmin,struc,dimxpntr,xpntr,namepntr,nxold,rsetbegin,rsetnum,
     *   parref,rsetref,splref,resref,beginspl,nodepos,
     *   numnodes,spltype,nfreq,freqloc,freqcat,freqs,parpos,branch,
     *   rsnamax,rsnpmax,xdim,vdim,iobs,id,ipt,jpt,originstats,
     *   rsetstats,xnode,x,v,iflam,detail,check99999,
     *   resname,oldname,splname)
 
c     Poisson model elements:
      if(nepo.gt.0)call figdata5(levelmax,nbdim,nb,nb2,nepo,neint,
     *   datadim,nummodel,vdimmax,numrset,numspl,maxref,numpar,nold,
     *   nfull,numdist,sumdim,maxdraws,distdim,distyp,lamtyp(1,7),
     *   lamrow(1,7),sparsity,distpos,dimused,intpnts,fulltype,
     *   ndraw,draws,draw(1,neh+nel+nep+nec+neb+nen+1),maxxnode,
     *   maxmeno,maxnmapmoel,maxnfreq,maxfreqcat,58,modeltype,mdllvl,
     *   strctre,moel,moelpntr,mapmoel,datas,minlnl,nmapmoel,
     *   plusmin,struc,dimxpntr,xpntr,namepntr,nxold,rsetbegin,rsetnum,
     *   parref,rsetref,splref,resref,beginspl,nodepos,
     *   numnodes,spltype,nfreq,freqloc,freqcat,freqs,parpos,branch,
     *   rsnamax,rsnpmax,xdim,vdim,iobs,id,ipt,jpt,originstats,
     *   rsetstats,xnode,x,v,iflam,detail,check99999,
     *   resname,oldname,splname)
 
c     Multinomial logit model elements:
      vpntr7=vdim+1
      mp7=nmapmoel+1
      if(neml.gt.0)call figdata71(levelmax,nbdim,nb,nb2,nummodel,
     *   moelpntr,xdim,vdim,maxxnode,struc,modeltype,mdllvl,strctre,
     *   vdimmax,neml,neint,maxmeno,moel,maxnmapmoel,mapmoel,
     *   datas,minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,distdim,
     *   maxdraws,draws,draw(1,neh+nel+nep+nec+neb+nen+nepo+1),ndraw,
     *   dimused,distyp,lamtyp(1,8),lamrow(1,8),
     *   sparsity,distpos,dimxpntr,xpntr,nfull,fulltype,maxref,
     *   parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *   numspl,beginspl,nodepos,numnodes,spltype,splref,datadim,
     *   rsmlmax,maxfreqcat,nfreq,maxnfreq,branch,prevbranch,freqloc,
     *   freqcat,freqs,namepntr,nxold,nold,originstats,
     *   rsetstats,x,v,xnode,distvar,oldname,
     *   iflam,detail,check99999,splname,resname,iobs,id,ipt,jpt)
 
c     Number of modules with at least one integrated residual:
      neint=abs(neint)
 
c     Subroutine figure_res tried to determine whether load matrices Lambda
c     are generic (lamtyp=0), identity (lamtyp=1), or sparse (lamtyp=4).
c     It may have incorrectly flagged some matrices as identity.  For example:
c        ( 1 0 0 )
c        ( 0 1 0 )        ( 1 0 0 )      ( 1 0 )
c        ( 0 0 1 )  or    ( 0 0 0 )  or  ( 0 0 )
c        ( 0 0 0 )
c        ( 0 0 0 )
c        ( 0 0 0 )
c     (First case arises in Test\Misc\nested1a, with (15,3) matrix; second
c     case in trouble\trouble10; third in Trouble\ribar).
c     Correct this assignment.  No need to check hazard, logit, or (negative)
c     binomial models, because their residuals must be integrated-out and
c     their lamtyp will always be generic (lamtyp=0), courtesy of figure_res.
c     lamrow() indicates the last recorded nonzero row.
c     nep,nec is the number of rows.
c     dim*ndraw() is the number of columns (but lamtyp()=1 implies dim=1)
      do 300 i=1,numdist
         if(lamtyp(i,3).eq.1)then
            if(lamrow(i,3).ne.nep)lamtyp(i,3)=4
            if(ndraw(i).ne.nep)lamtyp(i,3)=4
         endif
         if(lamtyp(i,4).eq.1)then
            if(lamrow(i,4).ne.nec)lamtyp(i,4)=4
            if(ndraw(i).ne.nec)lamtyp(i,4)=4
         endif
  300 continue
 
  999 return
      end
