      subroutine figure_par(levelmax,mdllvl,meno,maxmeno,moel,nmapmoel,
     *   mapmoel,maxxnode,nold,nxold,namepntr,maxref,parref,numpar,
     *   parpos,vdim,oldvdim,xpntr,branch,nbdim,nb,xdim,x,
     *   xnode,oldname,struc,iobs,id,ipt,jpt)
 
c     Subroutine to figure out what the location in the parameter vector
c     is of a parameter model reference.
c
c     moel(*) contains input information:
c     moel(1) = 2 this is a parameter
c     moel(2) = 1 reference is direct;
c               2 reference is direct of (inverse) matrix element
c               3 reference is indirect
c     moel(3)  = parameter rank number if moel(2)=1
c                parameter location (may be >nfull) if moel(2)=2
c                expression position in xnode if moel(2)=3
c
c     mapmoel(*) contains output information:
c        mapmoel(1) = 2 "this is a parameter"
c        mapmoel(2) =    parameter location in parameter vector (fullpar)
c
c     Constantijn Panis, 2 February 2000
c     Last change: allow zero reference number
 
      implicit none
      integer levelmax,mdllvl,meno,maxmeno,moel(maxmeno),nmapmoel,
     *   mapmoel(*),maxxnode,nold,nxold(levelmax),namepntr(levelmax),
     *   maxref,parref(maxref),numpar,parpos(numpar),vdim,oldvdim,
     *   xpntr(2:levelmax),branch(levelmax),nbdim,nb(nbdim,2),
     *   xdim,status,ref,loc,struc,iobs,id,ipt,jpt
      real x(xdim),xnode(maxxnode),refvar
      character oldname(nold)*8
 
c     Which definition?
      if(moel(meno+1).eq.1)then
c        Direct reference of rank number:
         ref=moel(meno+2)
         loc=parpos(ref)
      elseif(moel(meno+1).eq.2)then
c        Direct reference of (inverse) matrix element:
         loc=moel(meno+2)
      elseif(moel(meno+1).eq.3)then
         call evalexpr(1,maxxnode,xdim,moel(meno+2),nold,levelmax,
     *      mdllvl,nbdim,nb,branch,xpntr,nxold,namepntr,xnode,x,
     *      refvar,oldname,struc,iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
         if(refvar.eq.0.)then
c           This term and everything interacted with it drops out.
            call dropblock(vdim,oldvdim,nmapmoel,mapmoel,
     *         meno,maxmeno,moel,ipt,jpt)
            goto 999
         endif
         if(int(refvar).ne.refvar)goto 810
         call ref2def(int(refvar),maxref,parref,ref,status)
         if(status.gt.0)goto 800
         loc=parpos(ref)
      else
         call bug(ipt,jpt)
      endif
      meno=meno+3
 
      mapmoel(nmapmoel+1)=2
      mapmoel(nmapmoel+2)=loc
      nmapmoel=nmapmoel+2
      goto 999
 
  800 call norefmatch(1,struc,id,iobs,mdllvl,branch,ipt,jpt,maxxnode,
     *   xdim,levelmax,nbdim,nb,moel(meno+2),xpntr,nold,nxold,
     *   namepntr,refvar,xnode,x,oldname,'parameter','parameter')
  810 call norefmatch(2,struc,id,iobs,mdllvl,branch,ipt,jpt,maxxnode,
     *   xdim,levelmax,nbdim,nb,moel(meno+2),xpntr,nold,nxold,
     *   namepntr,refvar,xnode,x,oldname,'parameter','parameter')
      stop
  999 return
      end
