      subroutine get_element(n1,n2,dim,line,il,status)
 
c     Subroutine to read the name of a covariance element and compute
c     its rank number in the vector of standard deviations and
c     correlation coefficients.  Standard deviations must be SIGMA(n);
c     correlation coefficients RHO(n1,n2).
c
c     Constantijn Panis, 23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      integer dim,n1,n2,il,status,temp1,temp2
      character line*128
      logical smtxt
 
      status=0
      if(smtxt(4,line,il,'Sigma('))then
         call getint(4,n1,line,il,status)
         if(status.gt.0)goto 800
         n2=n1
         if(.not.smtxt(4,line,il,')'))goto 800
      elseif(smtxt(4,line,il,'Rho('))then
         call getint(4,temp1,line,il,status)
         if(status.gt.0)goto 800
         call getint(4,temp2,line,il,status)
         if(status.gt.0)goto 800
         n1=min(temp1,temp2)
         n2=max(temp1,temp2)
         if(n2.eq.n1.or.n2.gt.dim)goto 800
         if(.not.smtxt(4,line,il,')'))goto 800
      else
         goto 800
      endif
      goto 999
 
  800 status=1
  999 return
      end
