      subroutine getexedir(exedir,length)
 
c     Subroutine to determine the directory where the executable file
c     is located.  Arguments:
c
c        exedir [out] directory name, with(!) trailing slash:
c                     '/usr/bin/' or 'E:\AML\'
c        length [out] number of characters in directory name.  May be
c                     used to determine whether exedir was truncated.
c
c     If an error occurs, length=0 and exedir=' '
c
c     BUG: only 1024 characters are available to store the PATH environment
c     variable.  If this causes problems, ask the user to move the executable's
c     location toward the front of the PATH.
c
c     Note: this routine uses Fortran extensions getenv, getarg, and getcwd.
c
c     Constantijn Panis, 1 November 2001
c     Last change: getenv is subroutine on all platforms.
 
      implicit none
      integer length,nt0,nt1,match,backup,i,j,trm
      integer(2)zero
c     integer zero
      character exedir*128,pathcwd*1024,slash*1
      logical exist
      parameter(slash='\')
c     parameter(slash='/')
      data zero/0/
 
      call getarg(zero,exedir)
c     call getarg(zero,exedir)
      nt0=trm(exedir)
      if(nt0.le.4)then
         exedir=exedir(1:nt0)//'.exe'
         nt0=nt0+4
      elseif(exedir(nt0-3:nt0).ne.'.exe'.and.
     *       exedir(nt0-3:nt0).ne.'.EXE')then
         exedir=exedir(1:nt0)//'.exe'
         nt0=nt0+4
      endif
      call char1match(slash,exedir,nt0,match)
      if(match.eq.0)then
c        program was found from $path
         call getenv('PATH',pathcwd)
c        call getenv('PATH',pathcwd)
         if(pathcwd.eq.' ')goto 800
         nt1=trm(pathcwd)
         i=1
c        Path elements are separated by ';' on PC, ':' on UNIX
  100    call char1match(';',pathcwd(i:i),nt1-i+1,match)
c 100    call char1match(':',pathcwd(i:i),nt1-i+1,match)
         if(match.eq.0)match=nt1-i+2
         if(exist(pathcwd(i:i+match-2)//slash//exedir(1:nt0)))then
            exedir=pathcwd(i:i+match-2)//slash
            length=match
            if(exedir.eq.'.')then
               call getcwd(exedir)
c              call getcwd(exedir)
c              write(6,*)'CWD ='''//exedir(1:trm(exedir))//''''
               length=trm(exedir)
               exedir=exedir(1:length)//slash
               length=length+1
            endif
            goto 999
         endif
         i=i+match
         if(i.le.nt1)goto 100
         goto 800
      elseif(match.eq.1.or.(match.eq.3.and.exedir(2:2).eq.':'))then
c     elseif(match.eq.1)then
c        Argument was something like E:\AML or /usr/bin/program
         do 200 i=nt0,1,-1
            if(exedir(i:i).eq.slash)then
               exedir=exedir(1:i)
               length=i
               goto 999
            endif
  200    continue
      else
c        Argument was something like Develop/program or ../../bin/program
c        or Develop\program or ..\..\bin\program, relative to $cwd
         backup=0
  300    if(exedir(3*backup+1:3*backup+3).eq.'..'//slash)then
            backup=backup+1
            goto 300
         endif
         do 310 i=nt0,2,-1
            if(exedir(i:i).eq.slash)goto 320
  310    continue
         goto 800
  320    nt0=i-1
         call getcwd(pathcwd)
c        call getcwd(pathcwd)
c        write(6,*)'CWD ='''//pathcwd(1:trm(pathcwd))//''''
         if(pathcwd.eq.' ')goto 800
         nt1=trm(pathcwd)
         if(pathcwd(nt1:nt1).ne.slash)then
            pathcwd=pathcwd(1:nt1)//slash
            nt1=nt1+1
         endif
         do 330 i=1,backup
            do 340 j=nt1-1,1,-1
               if(pathcwd(j:j).eq.slash)goto 350
  340       continue
            goto 800
  350       nt1=j
  330    continue
         if(3*backup.eq.nt0.or.exedir(3*backup+1:nt0).eq.'.')then
            exedir=pathcwd(1:nt1)
            length=nt1
         else
            exedir=pathcwd(1:nt1)//exedir(3*backup+1:nt0)//slash
            length=nt1+nt0-3*backup+1
         endif
         goto 999
      endif
 
  800 exedir=' '
      length=0
  999 return
      end
