      character*12 function i2c(i,width)
 
c     Character function that returns the character string equivalent
c     of an integer.  This function handles integers between
c     -99,999,999,999 and 999,999,999,999, i.e., over a wider range
c     than an integer*4 number.
c
c     Arguments:
c        i     [in] input integer
c        width [in] minimum width.  If
c                   width<0 the string will take up abs(width) spaces
c                           with leading zeroes
c                   width=0 the string will be left-justified
c                   width>0 the string will take up width spaces
c                           with leading blanks.
c     If abs(width) is too small to represent the integer, the first
c     width characters of the string are filled with asterisks.
c
c     Constantijn Panis, 17 November 1999
c     Last change: extra argument width.
 
      implicit none
      integer i,width,ai,it,len
      character temp*12,zeroes*12,asterisks*12,c(0:9)*1
      data c/'0','1','2','3','4','5','6','7','8','9'/
      data zeroes,asterisks/'000000000000','************'/
 
      temp=' '
      ai=abs(i)
      it=13
  100 it=it-1
      temp(it:it)=c(mod(ai,10))
      ai=ai/10
      if(ai.gt.0)goto 100
      if(i.lt.0)then
         it=it-1
         temp(it:it)='-'
      endif
      len=13-it
 
      i2c=' '
      if(width.eq.0.or.len.eq.abs(width))then
         i2c(1:len)=temp(it:12)
      elseif(len.gt.abs(width))then
         i2c(1:abs(width))=asterisks(1:abs(width))
      elseif(width.lt.0)then
         i2c(1:-width)=zeroes(1:-width-len)//temp(it:12)
      else
         i2c(width-len+1:width)=temp(it:12)
      endif
 
      return
      end
 
 
