      subroutine makesym(n,a)
 
c     Subroutine to restore the symmetry of a square matrix by replacing
c     off-diagonal elements by the mean of the opposing elements, i.e.,
c        a(i,j) = (a(i,j)+a(j,i))/2
c        a(j,i) = a(i,j)
c
c     This routine is useful to maintain symmetry of matrices with
c     derivatives wrt covariance matrices.  The number of degrees of
c     freedom of a covariance matrix is only n*(n+1)/2, so it only
c     makes sense to maintain a similar number of derivatives.
c
c     Constantijn Panis, 18 October 1995
 
      implicit none
      integer n,i,j
      double precision a(n,n)
 
      do 100 i=1,n
         do 110 j=i+1,n
            a(i,j) = .5d0*(a(i,j)+a(j,i))
            a(j,i) = a(i,j)
  110    continue
  100 continue
 
      return
      end
