      subroutine msub(a,n1,n2,i1,i2,b,m1,m2,j1,j2,l1,l2)
 
c     Subroutine to copy a subset of an arbitrary matrix A into another
c     matrix B.  Arguments:
c
c     a        [in]   input matrix A
c     n1,n2    [in]   dimension of A(n1,n2)
c     i1,i2    [in]   top-left position of sub-matrix in input matrix A
c     b        [out]  output matrix B
c     m1,m2    [in]   dimension of B(m1,m2)
c     j1,j2    [in]   top-left position of sub-matrix in output matrix B
c     l1,l2    [in]   dimension of the sub-matrix to be copied
c
c     Note an alternative use of msub:  if the l1*l2 elements of a
c     sub-matrix need to be moved up to be, say, the first l1*l2
c     elements of the big matrix, then calling msub with matrix and
c     submatrix being the same will do the trick:
c     call msub(sigma,n1,n2,i1,i2,l1,l2,1,1,sigma)
c     Matrix sigma can then be used in another subroutine as a
c     (l1,l2) matrix; of course its original contents are lost.
c
c     Constantijn Panis,  17 october 2002
c     Last change: allow j1,j2
 
      implicit none
      integer n1,n2,i1,i2,m1,m2,j1,j2,l1,l2,i,j
      double precision a(n1,n2),b(m1,m2)
 
      do 100 j=1,l2
         do 110 i=1,l1
            b(j1-1+i,j2-1+j) = a(i1-1+i,i2-1+j)
  110    continue
  100 continue
 
      return
      end
