      subroutine needmemory(maxcc,ccmax,nemax,ipt,jpt)
 
c     Subroutine to write out the error message that insufficient
c     memory was allocated.  This routine always terminates execution.
c
c     Constantijn Panis, 6 July 1996
 
      implicit none
      integer ipt,jpt,maxcc,ccmax,nemax
 
      if(maxcc.eq.0.and.ccmax.eq.0)then
c        Calling program did not know maxcc/ccmax, only that maxcc
c        was exceeded.
         if(ipt.gt.0)write(8,101)
         if(jpt.gt.0)write(6,101)
  101    format(/,'ERROR:  the maximum dimension of scratch arrays ',
     *      'is exceeded.')
      else
         if(ipt.gt.0)call writeaia(8,72,1,'ERROR:  the maximum '//
     *      'dimension of scratch arrays (',maxcc,' bytes) is '//
     *      'exceeded.')
         if(jpt.gt.0)call writeaia(6,72,1,'ERROR:  the maximum '//
     *      'dimension of scratch arrays (',maxcc,' bytes) is '//
     *      'exceeded.')
      endif
      if(ipt.gt.0)write(8,102)
      if(jpt.gt.0)write(6,102)
  102 format(/,'This is highly unusual and should only occur in ',
     *   'exceptionally large',/,'problems.  Typically, aML runs out ',
     *   'of memory due to a very high number',/,'of outcomes (and ',
     *   'thus equations) in any one observation, implying very',/,
     *   'large residual covariance matrices.')
      if(nemax.gt.0)then
         if(ipt.gt.0)call writeaia(8,72,1,'In your model, there '//
     *      'are as many as ',nemax,' outcomes per observation.')
         if(jpt.gt.0)call writeaia(6,72,1,'In your model, there '//
     *      'are as many as ',nemax,' outcomes per observation.')
      endif
      if(maxcc.eq.4000000)then
         if(ipt.gt.0)write(8,103)
         if(jpt.gt.0)write(6,103)
  103    format(/,'To allocate more (64MB) scratch space, run ',
     *      '"bigaml" instead of "aml"',/,'(but only if your machine ',
     *      'has more than about 96MB RAM).')
      elseif(maxcc.eq.64000000)then
         if(ipt.gt.0)write(8,104)
         if(jpt.gt.0)write(6,104)
  104    format(/,'To allocate even more (128MB) scratch space, run ',
     *      '"hugeaml" instead of',/,'"bigaml" (but only if your ',
     *      'machine has more than about 160MB RAM).')
      endif
      if(ipt.gt.0)write(8,105)
      if(jpt.gt.0)write(6,105)
  105 format(/,'Please visit our FAQ (Frequently Asked Questions) ',
     *   'webpage at',/,'http://www.applied-ml.com/support/faq.html#',
     *   'memory for more information.')
 
      stop
      end
