      subroutine norefmatch(task,struc,id,iobs,mdllvl,branch,ipt,jpt,
     *   maxxnode,xdim,levelmax,nbdim,nb,moelpos,xpntr,nold,nxold,
     *   namepntr,refvar,xnode,x,oldname,rhsblock,buildblock)
 
c     Subroutine to write out two types of error messages:
c
c     task=1:
c
c     ERROR:  the reference value of an indirectly referenced regressor
c     set cannot be matched to any defined regressor set.  The
c     reference variable is (data structure=100, obs=23, ID=13,
c     branch=4):
c     100*x1+10*x2+5 = 100*45+10*4+5 = 4545
c
c     task=2:
c
c     ERROR:  the reference value of an indirectly referenced regressor
c     set is not an integer (data structure=100, obs=23, ID=13,
c     branch=4):
c     100*x1+10*x2+5 = 100*45+10*4+5 = 4545
c
c     This routine aborts execution.
c
c     Constantijn Panis, 22 May 1998
 
      implicit none
      integer task,struc,id,iobs,mdllvl,branch(mdllvl),ipt,jpt,maxxnode,
     *   xdim,levelmax,nbdim,nb(nbdim,2),moelpos,xpntr(2,levelmax),
     *   nold,nxold(levelmax),namepntr(levelmax),trm
      real xnode(maxxnode),x(xdim),refvar
      character oldname(nold)*8,rhsblock*(*),buildblock*(*),
     *   string*60,idstring*60,rhs*32,build*32
 
      string=idstring(struc,id,iobs,mdllvl,branch)
      rhs=rhsblock
      build=buildblock
      if(task.eq.1)goto 800
      if(task.eq.2)goto 810
      call bug(ipt,jpt)
 
  800 if(ipt.gt.0)then
         call wrapstring(8,0,72,0,1,'ERROR: the reference value of '//
     *      'an indirectly referenced '//rhs(1:trm(rhs))//
     *      ' cannot be matched to any defined '//
     *      build(1:trm(build))//'.  The '//
     *      'reference variable is ('//string(1:trm(string))//'):')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -abs(moelpos),nb,branch,xpntr,1,nold,nxold,namepntr,
     *      -1,refvar,xnode,x,oldname,struc)
      endif
      if(jpt.gt.0)then
         call wrapstring(6,0,72,0,1,'ERROR: the reference value of '//
     *      'an indirectly referenced '//rhs(1:trm(rhs))//
     *      ' cannot be matched to any defined '//
     *      build(1:trm(build))//'.  The '//
     *      'reference variable is ('//string(1:trm(string))//'):')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -abs(moelpos),nb,branch,xpntr,1,nold,nxold,namepntr,
     *      -1,refvar,xnode,x,oldname,struc)
      endif
      stop
 
  810 if(ipt.gt.0)then
         call wrapstring(8,0,72,0,1,'ERROR: the reference value of '//
     *      'an indirectly referenced '//build(1:trm(build))//
     *      ' is not an integer ('//string(1:trm(string))//'): ')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -abs(moelpos),nb,branch,xpntr,1,nold,nxold,namepntr,
     *      -1,refvar,xnode,x,oldname,struc)
      endif
      if(jpt.gt.0)then
         call wrapstring(6,0,72,0,1,'ERROR: the reference value of '//
     *      'an indirectly referenced '//build(1:trm(build))//
     *      ' is not an integer ('//string(1:trm(string))//'): ')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -abs(moelpos),nb,branch,xpntr,1,nold,nxold,namepntr,
     *      -1,refvar,xnode,x,oldname,struc)
      endif
      stop
 
      end
