      subroutine onemnlogit(neml,nneml,draw,cdraw,xbml,dxbml,epsml,lnl,
     *   v,ifdrv,ipt,jpt,status)
 
c     Subroutine to compute the log-likelihood of multinomial logit outcomes.
c     Upon return, status is
c        0 if normal execution
c       -1 if the likelihood underflows to zero
c
c     Constantijn Panis, 10 December 2002
c     Last change: less underflow detection
 
      implicit none
      integer neml,nneml,draw(neml),cdraw,ipt,jpt,status
      double precision lnl,epsml(nneml),xbml(nneml),dxbml(nneml),
     *   denom,tmp,maxexp
      real v(2*neml)
      integer ie,iie,iie1,iiee,neqn,eqn,outcome
      logical ifdrv
 
      status=0
      iie=0
      do 100 ie=1,neml
         neqn=int(v(2*ie-1))
         outcome=int(v(2*ie))
c        Do we need to evaluate this (conditional) likelihood module?
         if(cdraw.ne.draw(ie))then
            iie=iie+neqn
            goto 100
         endif
         denom=1.d0
         iie1=iie+1
         do 110 eqn=1,neqn
            iie=iie+1
            tmp=xbml(iie)+epsml(iie)
c           If outcome=0=omitted category, add log(1)=0, i.e., nothing
            if(outcome.eq.eqn)then
               lnl=lnl+tmp
               iiee=iie
            endif
c           In case of overflow, there may be circumstances under which
c           lnl=0, but in no case do derivatives add anything.
            if(tmp.ge.maxexp())goto 900
            denom=denom+dexp(tmp)
            if(.not.ifdrv)goto 110
            dxbml(iie)=-dexp(tmp)
  110    continue
         lnl = lnl - dlog(denom)
         if(.not.ifdrv)goto 100
         call mult(dxbml(iie1),1.d0/denom,dxbml(iie1),neqn)
         if(outcome.ne.0)dxbml(iiee)=dxbml(iiee)+1.d0
  100 continue
      goto 999
 
c     Likelihood underflows to zero:
  900 status=-1
  999 return
      end
