      subroutine outerp_wt(u1,u2,m,n1,n2,weight,accumulate)
 
c     Subroutine to compute the outerproduct of 2 vectors and multiply
c     the outcome times a weight.
c     If accumulate=.false. only compute the outerproduct:  M = weight*u1*u2'
c     If accumulate=.true. accumulate the outerproduct: M = M + weight*u1*u2'
c
c     Constantijn Panis,  10 December 1991
 
      implicit none
      integer n1,n2,i
      double precision u1(n1),u2(n2),m(n1,n2),weight
      logical accumulate
 
      if(accumulate)then
         do 100 i=1,n2
            call add(u1,m(1,i),weight*u2(i),n1)
  100    continue
      else
         do 200 i=1,n2
            call mult(u1,weight*u2(i),m(1,i),n1)
  200    continue
      endif
 
      return
      end
