      integer function posnb(level,branch,nbdim,nb)
 
c     Integer function to determine the position in nb where numbers
c     of branches of level level begin.
c        level  [in] level where subbranches need to be found
c        branch [in] vector indicating which level 2 and higher branch
c                    is taken to level level
c        nbdim  [in] dimension of nb
c        nb     [in] matrix containing numbers of subbranches
c
c     Note:  if a branch does not exist, posnb=0
c
c     Constantijn Panis, 11 July 1996
 
      implicit none
      integer level,branch(level),nbdim,nb(nbdim,2),num,pos,ll
 
      posnb=0
      if(level.lt.0)goto 999
 
      pos=2
      do 100 ll=2,level
         num=nb(pos,1)
c        Does specified branch number exist?
         if(branch(ll).gt.num)goto 999
         if(nb(pos,2).eq.0)goto 999
         pos=nb(pos,2)-1+branch(ll)
         if(pos.eq.0)goto 999
  100 continue
 
      posnb=pos
 
  999 return
      end
