      subroutine prep6(task,nec,nfullplus,numarma,nmapmoel,dimv,mapmoel,
     *   moelpos,rscmax,numdist,distdim,dimlam,lamtyp6,lampos6,xbc,dxbc,
     *   fullbeta,dfullbeta,lam,dlam,v,vpntr,ipt,jpt)
 
c     Subroutine to process model elements for continuous models,
c     looping over all nec continuous episodes.
c
c     If task=1, regressor sets and parameters are placed in xbc and
c     interacted if appropriate.  If the resulting regressor set enters
c     as part of Beta'X, it is accumulated into xbc(.,0).  If it is
c     interacted with a residual, it is placed in Lambda6,
c     which will pre- and post-multiply the (blown up) covariance matrix
c     of the corresponding distribution in subroutine computesigmae.
c
c     If task=2, derivatives are unraveled.  Subroutine dnormk4 returns
c     derivatives wrt regressor sets in dxbc(.,0), and wrt residual
c     structures (incl interactions) in dsigmae.  The latter are unraveled
c     into wrt (blown up) covariance matrices and wrt Lambda in subroutine
c     computesigmae.  Derivatives wrt Lambda are further unraveled here,
c     by collapsing them into regressor sets that are subsequently unraveled
c     into individual parameters dfullbeta.
c
c     Constantijn Panis, 24 July 1996
 
      implicit none
      integer task,nec,nfullplus,numarma,nmapmoel,mapmoel(nmapmoel),
     *   moelpos,dimv,rscmax,numdist,distdim(numdist),dimlam,
     *   lamtyp6(numdist),lampos6(numdist),vpntr,ie,ipt,jpt
      double precision xbc(nec,0:rscmax),dxbc(nec,0:1),
     *   fullbeta(nfullplus),dfullbeta(nfullplus),lam(dimlam),
     *   dlam(dimlam)
      real v(dimv)
 
      vpntr=vpntr+(2*numarma+1)*nec
      if(v(vpntr).ne.real(nec))call bug(ipt,jpt)
      vpntr=vpntr+1
      do 100 ie=1,nec
         call prepfunc(task,ie,nec,nec,nmapmoel,dimv,mapmoel,moelpos,
     *      vpntr,nfullplus,rscmax,numdist,distdim,dimlam,lamtyp6,
     *      lampos6,fullbeta,dfullbeta,xbc,dxbc,lam,
     *      dlam,0.d0,v,ipt,jpt)
  100 continue
 
  999 return
      end
