      subroutine prepcov(task,nfull,numdist,sumdim2,distdim,distyp,
     *   distpos,distrestrpos,distrestr,fullbeta,dfullbeta,
     *   sigdd,dsigdd,fullname,posdef,ipt,jpt,status)
 
c     Subroutine to create covariance matrices of all distributions,
c     not expanded.  Also unravel derivatives.
c
c     Constantijn Panis, 29 Augsut 2002
c     Last change: intriduce status
 
      implicit none
      integer task,nfull,numdist,sumdim2,distdim(numdist),
     *   distyp(numdist),distpos(numdist),distrestrpos(numdist),
     *   distrestr(0:sumdim2),ipt,jpt,status,posdef,pos,posdd,dim,i
      double precision fullbeta(nfull),dfullbeta(nfull),
     *   sigdd(sumdim2),dsigdd(sumdim2)
      character fullname(nfull)*8
 
      status=0
      posdd=1
      if(task.eq.2)goto 200
 
      do 110 i=1,numdist
         dim=distdim(i)
c        Create correlation matrix (except for finite mixtures):
         if(mod(distyp(i),10).eq.4)goto 130
c        C/ARMA distributions have p autoregressive parameters preceding
c        the standard deviation of the innovation, which is needed here.
         pos=distpos(i)
         if(mod(distyp(i),10).eq.2.or.mod(distyp(i),10).eq.3)pos=pos+
     *      mod(distyp(i),1000)/100
c        Convert fullbeta into correlation matrix and check that it is
c        positive definite.  If not, reduce all correlations equally
c        until positive definite.
         call ensposdef(dim,distrestr(distrestrpos(i)),ipt,jpt,
     *      fullbeta(pos),sigdd(posdd),fullname(pos),posdef,status)
         if(status.ne.0)goto 999
c        Convert correlation into covariance matrix
         call corr2cov(1,dim,sigdd(posdd),sigdd(posdd),0.d0,0.d0)
c        Allocate space for all covariances, even for finite mixtures
c        which are not used.
  130    posdd=posdd+dim*dim
  110 continue
      goto 999
 
c     Map derivatives wrt covariance matrices into wrt parameters fullbeta.
c     (Only the variance of the innovation term of ARMA processes
c     is dealt with here.)
  200 do 210 i=1,numdist
c        Finite mixtures are treated separately:
         if(mod(distyp(i),10).eq.4)goto 220
         dim=distdim(i)
         call corr2cov(2,dim,sigdd(posdd),sigdd(posdd),dsigdd(posdd),
     *      dsigdd(posdd))
         pos=distpos(i)
         if(mod(distyp(i),10).eq.2.or.mod(distyp(i),10).eq.3)pos=pos+
     *      mod(distyp(i),1000)/100
         call map_corr(2,dim,fullbeta(pos),dfullbeta(pos),
     *      sigdd(posdd),dsigdd(posdd),distrestr(distrestrpos(i)),dim+1)
  220    posdd=posdd+dim*dim
  210 continue
      goto 999
 
  999 return
      end
