      subroutine setupfunc(task,nfree,ifdrv,lnl,fp,fpt,sp,spt)
 
c     Subroutine to initialize the function value, first, and second
c     derivatives to zero, and to determine ifdrv.
c
c     Argument task indicates what will be set to zero:
c        100 = function value
c         20 = first derivatives  (untransformed parameters only)
c         10 = first derivatives  (transformed and untransformed parameters)
c          2 = second derivatives (untransformed parameters only)
c          1 = second derivatives (transformed and untransformed parameters)
c
c     Constantijn Panis,  24 January 1996
c     Last change: ability to deal with derivatives wrt untransformed
c     parameters only.
 
      implicit none
      integer task,nfree
      double precision lnl,fp(nfree),fpt(nfree),sp(nfree,nfree),
     *   spt(nfree,nfree)
      logical ifdrv
 
      if(task/100.eq.1)lnl = 0.d0
      ifdrv=(mod(task,100).gt.0)
      if(.not.ifdrv)goto 999
 
      if(mod(task/10,10).eq.1.or.mod(task/10,10).eq.2)
     *   call zerodp(nfree,fp)
      if(mod(task/10,10).eq.1)call zerodp(nfree,fpt)
 
      if(mod(task,10).eq.1.or.mod(task,10).eq.2)
     *   call zerodp(nfree*nfree,sp)
      if(mod(task,10).eq.1)call zerodp(nfree*nfree,spt)
 
  999 return
      end
