      subroutine sizedraw(numdist,ne,olddraw,newdraw,ndraw,nested,
     *   neh,nel,nep,nec)
 
c     Subroutine to reduce the size of draw(numdist,ne) to draw(ne)
c     by combining the (low) integer valued column elements into scalars.
c     The procedure is as follows.  Elements corresponding to
c     non-integrated distributions are ignored.  For the others:
c        newdraw(ie) = sum(numdist){draw*(ndraw(i)+1)+draw(i,ie)}
c
c     Special care is taken to ensure that olddraw and newdraw may share
c     memory space.
c
c     Constantijn Panis, 16 July 1997
 
      implicit none
      integer numdist,ne,olddraw(numdist,ne),newdraw(ne),ndraw(numdist),
     *   nested(numdist,2),neh,nel,nep,nec,ie,combidraw
 
      if(numdist.eq.0)then
         call zeroint(ne,newdraw)
c        Note: if there are no distributions, there are no continuous modules,
c        so there is no need to re-set combination draws.
         goto 999
      endif
 
      do 100 ie=1,ne
         newdraw(ie)=combidraw(numdist,olddraw(1,ie),nested,ndraw)
  100 continue
c     Set combination draws of continuous modules which are not integrated-out
c     to -1, so that they will not be evaluated in subroutine integrate when
c     all thisdraw(*)=0.
      do 200 ie=neh+nel+nep+1,neh+nel+nep+nec
         if(newdraw(ie).eq.0)newdraw(ie)=-1
  200 continue
 
  999 return
      end
