      subroutine timestamp(date_time)
 
c     Subroutine to return the date and time.
c
c     For SUN f77, extension fdate is used.
c
c     For Fortran 90, I modified subroutine timestamp2 as provided by
c     MIGRATING TO FORTRAN 90 by James F. Kerrigan, published by
c     O'Reilly & Associates, Inc. in the September, 1994 printing.
c
c     The result is something like "Tue May 28 15:56:47 1996"
c
c     Constantijn Panis, 17 November 1999
c     Last change: new use of i2c.
 
      implicit none
      character date_time*24
      integer values(8),m,y,w
      character days(0:6)*3,months(12)*3,weekday*3,year*4,day*2,
     *   month*3,hour*2,minute*2,second*2,i2c*12
      data days/'Sun','Mon','Tue','Wed','Thu','Fri','Sat'/
      data months/'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug',
     *   'Sep','Oct','Nov','Dec'/
 
c     Retrieve and format the system date and time.
c     call fdate(date_time)
      call date_and_time(VALUES=values)
      if(values(1).ne.-HUGE(values))then
         y=values(1)
         m=values(2)
         if(m.lt.3)then
            m=m+12
            y=y-1
         endif
         w=mod((values(3)+(13*m-27)/5+y+y/4-y/100+y/400),7)
 
         weekday=days(w)
         year=i2c(values(1),4)
         day=i2c(values(3),2)
         month=months(values(2))
         hour=i2c(values(5),2)
         minute=i2c(values(6),-2)
         second=i2c(values(7),-2)
         date_time = weekday//' '//month//' '//day//' '//
     *      hour//':'//minute//':'//second//' '//year
      else
         date_time=' '
      endif
 
 
      return
      end
