      real function varnext()
 
c     Real function to return the internal representation of varnext,
c     the number which is used by readexpr to denote that the next
c     term is a variable.  Varnext is the real equivalent of 10,000,001,
c     i.e., about
c
c     Note: an earlier version set varnext=realequiv(1,000,000).  The
c     Digital f90 compiler on Compaq Alpha (OSF1) complained of a floating
c     point error.  This number appeared to be too low.  on a SUN, the
c     minimum real number is realequiv(8,388,608)=1.17549E-38.
c
c     The following special numbers are in use:
c                     integer         real        hexadecimal:
c        varnext     10,000,001    1.40130E-38      00989681
c        opernext    10,000,002    1.40130E-38      00989682
c        enditem     10,000,003    1.40130E-38      00989683
c        endexpr     10,000,004    1.40130E-38      00989684
c        endexprs    10,000,005    1.40130E-38      00989685
c
c     Constantijn Panis, 15 November 2000
c     Last change: 10,000,001 instead of 1,000,000.
 
      implicit none
      integer i
      real x
      equivalence(i,x)
      data i/10000001/
 
      varnext=x
 
      return
      end
