      subroutine wr_d_dist(unit,numdist,sumdim,dimmax,maxref,distpos,
     *   distdim,distyp,distrestrpos,distrestr,fulltype,resref,intpnts,
     *   distvar,fullname,resname,parname,corrname,ipt,jpt)
 
c     Subroutine to write out definitions of distributions and the names
c     of their standard deviations and correlation coefficients, from
c     which potential restrictions are clear.
c
c     The following was taken out 1/28/97 but needs to be put back
c     in in different form:
c     Also write out a frequency table of number of outcomes in
c     which dimensions of the integrated distribution enter.
c
c     Constantijn Panis, 1 February 2000
c     Last change: new style
 
      implicit none
      integer unit,numdist,sumdim,dimmax,maxref,distpos(numdist),
     *   distdim(numdist),distyp(numdist),distrestrpos(numdist),
     *   distrestr(0:*),fulltype(*),resref(maxref),intpnts(sumdim),
     *   dist,restrpos,ipt,jpt,dim,dimp1,dimpos,refpos,distype,
     *   i,j,ii,i1,i2,j1,j2,n,nt,l,p,q,col,trm,intvecsum
      character distvar(numdist)*8,fullname(*)*8,resname(*)*12,
     *   parname(*)*12,corrname(dimmax,dimmax)*8,
     *   vector*12,name1*8,name2*8,fmt*24,i2c*12
 
      if(numdist.eq.0)goto 999
      refpos=1
      dimpos=0
      write(unit,101)
  101 format(/,'The following distributions have been defined:')
      do 100 dist=1,numdist
         p=0
         q=0
         dim=distdim(dist)
         distype=abs(distyp(dist))
         write(unit,'(1x)')
         if(distype.eq.1)then
c           Normal distribution
            call writeaia(unit,72,1,'define normal distribution;  dim=',
     *         dim,';')
            n=intvecsum(distdim,dist-1)
            if(intpnts(n+1).gt.0)then
c              write(unit,103)
               write(unit,103)
cD              write(unit,103,advance='no')
c 103          format(3x,'number of integration points =',$)
  103          format(3x,'number of integration points =',$)
cD 103          format(3x,'number of integration points =')
               do 110 i=1,dim
                  call writeint(unit,intpnts(n+i),1,0)
  110          continue
               write(unit,'(a)')';'
            endif
         elseif(mod(distype,10).eq.2)then
c           ARMA distribution
            l = distype/1000
            p = mod(distype,1000)/100
            q = mod(distype,100)/10
            if(p.gt.0.and.q.gt.0)then
               call writea2ia(unit,72,1,'define ARMA(',p,',',q,
     *            ') distribution;  dim=1;')
            elseif(p.gt.0)then
               call writeaia(unit,72,1,'define AR(',p,
     *            ') distribution;  dim=1;')
            elseif(q.gt.0)then
               call writeaia(unit,72,1,'define MA(',q,
     *            ') distribution;  dim=1;')
            else
               call bug(ipt,jpt)
            endif
         elseif(mod(distype,10).eq.3)then
c           Cumulative ARMA distribution: only CAR(1) supported
            l = distype/1000
            p = mod(distype,1000)/100
            q = mod(distype,100)/10
            if(p.ne.1.or.q.ne.0)call bug(ipt,jpt)
            write(unit,'(a)')'define CAR(1) distribution;  dim=1;'
         elseif(mod(distype,10).eq.4)then
c           Finite mixture distribution
c           distyp=10000*n1+10*n2+4  where n1 is vector of points and n2 of weig
            write(unit,'(a)')
     *         'define finite mixture distribution;  dim=1;'
            write(unit,'(3x,a)')'form=asymmetric;'
            vector=parname(distype/10000)
            n=intpnts(intvecsum(distdim,dist-1)+1)
            call writeaia(unit,72,1,'   points='//
     *         vector(1:trm(vector))//';  /* ',n,' support points */')
            vector=parname(mod(distype,10000)/10)
            write(unit,'(3x,a)')'weights='//vector(1:trm(vector))//';'
         endif
c        Write names and reference numbers
         do 120 i=1,dim
            nt=trm(resname(dimpos+i))
            call intmatch(0,resref(refpos),maxref-refpos+1,n)
            if(n.eq.0)call bug(ipt,jpt)
            n=n-1
            if(n.eq.0)then
               write(unit,105)resname(dimpos+i)(1:nt)
  105          format(3x,'name=',a,';')
            elseif(resname(dimpos+i).eq.'(noname)')then
c              write(unit,106)
               write(unit,106)
cD              write(unit,106,advance='no')
c 106          format(3x,'name=;',t20,'ref=',$)
  106          format(3x,'name=;',t20,'ref=',$)
cD 106          format(3x,'name=;',t20,'ref=')
               call writeints(unit,resref(refpos),n,0,1)
            else
c              write(unit,107)resname(dimpos+i)(1:nt)
               write(unit,107)resname(dimpos+i)(1:nt)
cD              write(unit,107,advance='no')resname(dimpos+i)(1:nt)
c 107          format(3x,'name=',a,';',t20,'ref=',$)
  107          format(3x,'name=',a,';',t20,'ref=',$)
cD 107          format(3x,'name=',a,';',t20,'ref=')
               call writeints(unit,resref(refpos),n,0,1)
            endif
            refpos=refpos+n+1
  120    continue
         if(resref(refpos).ne.-1)call bug(ipt,jpt)
         refpos=refpos+1
         dimpos=dimpos+dim
 
c        Cholesky search?
         if(fulltype(distpos(dist)).eq.5)write(unit,'(3x,a)')
     *      'search=cholesky;'
 
         if(p+q.gt.0)then
            nt=trm(distvar(dist))
            call writeaia(unit,72,0,'   timevar (within level ',
     *         l,') = '//distvar(dist)(1:nt)//';')
            if(distyp(dist).lt.0)write(unit,'(a)')' increasing=no;'
            if(distyp(dist).gt.0)write(unit,'(1x)')
            if(p.eq.1)then
               name1=fullname(distpos(dist))
               write(unit,111)name1(1:trm(name1))
  111          format(3x,'/* autoregressive coefficient: ',a,' */')
            elseif(p.gt.1)then
               name1=fullname(distpos(dist))
               name2=fullname(distpos(dist)+p-1)
               write(unit,112)name1(1:trm(name1)),name2(1:trm(name2))
  112          format(3x,'/* autoregressive coefficients: ',a,' - ',
     *            a,' */')
            endif
            name1=fullname(distpos(dist)+p)
            write(unit,113)name1(1:trm(name1))
  113       format(3x,'/* coefficient for standard deviation of ',
     *         'innovation: ',a,' */')
            if(q.eq.1)then
               name1=fullname(distpos(dist)+p+1)
               write(unit,114)name1(1:trm(name1))
  114          format(3x,'/* moving average coefficient: ',a,' */')
            elseif(q.gt.1)then
               name1=fullname(distpos(dist)+p+1)
               name2=fullname(distpos(dist)+p+q)
               write(unit,115)name1(1:trm(name1)),name2(1:trm(name2))
  115          format(3x,'/* moving average coefficients: ',a,' - ',
     *            a,' */')
            endif
         endif
 
c        Write restrictions and coefficient names of correlation matrix:
         if(distype.gt.1)goto 100
         restrpos=distrestrpos(dist)
         dimp1=dim+1
         if(dim.eq.1)then
c           Not really a matrix; cannot be restrictions:
            nt=trm(fullname(distpos(dist)))
            write(unit,121)fullname(distpos(dist))(1:nt)
  121       format(3x,'/* coefficient for standard deviation: ',a,' */')
            goto 100
         elseif(restrpos.eq.0)then
c           No restrictions:
            write(unit,122)
c           /* NOTE: no restrictions are placed on standard deviations or    */
c           /* correlation coefficients.  The following matrix shows names   */
c           /* of standard deviations (on the diagonal) and correlation      */
c           /* coefficients off-diagonal) in the starting values.            */
  122       format(3x,'/* NOTE: no restrictions are placed on ',
     *         'standard deviations or    */',/,3x,'/* correlation ',
     *         'coefficients.  The following matrix shows names   */',/,
     *         3x,'/* of standard deviations (on the diagonal) and ',
     *         'correlation      */',/,3x,'/* coefficients (off ',
     *         'the diagonal) in the starting values.       */')
            ii=distpos(dist)+dim-1
            do 130 i2=1,dim
               corrname(i2,i2)=fullname(distpos(dist)+i2-1)
               do 140 i1=i2+1,dim
                  ii=ii+1
                  corrname(i1,i2)=fullname(ii)
  140          continue
  130       continue
         else
c           There are restrictions:
            restrpos=restrpos-1
            ii=distpos(dist)-1
            do 160 i1=1,dim
               j1=mod(distrestr(restrpos+i1+dim*(i1-1)),dimp1)
               if(j1.ne.i1)call writea2ia(unit,72,1,
     *            '   restriction sigma(',j1,')=sigma(',i1,');')
  160       continue
            do 170 i2=1,dim
               do 180 i1=i2+1,dim
                  j1=mod(distrestr(restrpos+i1+dim*(i2-1)),dimp1)
                  j2=distrestr(restrpos+i1+dim*(i2-1))/dimp1
                  if(j1.ne.i1.or.j2.ne.i2)call writea4ia(unit,72,1,
     *               '   restriction rho(',j1,',',j2,
     *               ')=rho(',i1,',',i2,');')
  180          continue
  170       continue
            do 220 i1=1,dim
               if(i1.ne.distrestr(restrpos+i1+dim*(i1-1))/dimp1)goto 220
               ii=ii+1
               corrname(i1,i1)=fullname(ii)
  220       continue
            do 230 i2=1,dim
               do 235 i1=i2+1,dim
                  if(i1.ne.mod(distrestr(restrpos+i1+dim*(i2-1)),dimp1)
     *               .or.i2.ne.distrestr(restrpos+i1+dim*(i2-1))/dimp1)
     *               goto 235
                  ii=ii+1
                  corrname(i1,i2)=fullname(ii)
  235          continue
  230       continue
            do 240 i2=1,dim
               do 245 i1=i2,dim
                  j1=mod(distrestr(restrpos+i1+dim*(i2-1)),dimp1)
                  j2=distrestr(restrpos+i1+dim*(i2-1))/dimp1
                  corrname(i1,i2)=corrname(j1,j2)
  245          continue
  240       continue
            write(unit,123)
c           /* NOTE: restrictions are placed on standard deviations or       */
c           /* correlation coefficients.  The following matrix shows the     */
c           /* names of standard deviations (on the diagonal) and            */
c           /* correlation coefficients (off the diagonal) in the starting   */
c           /* values.  Please check this matrix carefully:                  */
  123       format(3x,'/* NOTE: restrictions are placed on standard ',
     *         'deviations or       */',/,3x,'/* or correlation ',
     *         'coefficients.  The following matrix shows the  */',/,
     *         3x,'/* names of standard deviations (on the diagonal) ',
     *         'and',t69,'*/',/,3x,'/* correlation coefficients (off ',
     *         'the diagonal) in the starting   */',/,3x,'/* values.  ',
     *         'Please check this matrix carefully:',t69,'*/')
         endif
c        Where should we put the closing "*/"?
         col=max(63,3+10*dim)
         do 250 i=1,dim
c           Format is something like '(3x,a2,2x,4a10,a23)'
            fmt='(3x,a2,2x,'//i2c(i,0)
            fmt=fmt(1:trm(fmt))//'a10,a'//i2c(col-10*i,0)
            fmt=fmt(1:trm(fmt))//')'
            write(unit,fmt)'/*',(corrname(i,j),j=1,i),'*/'
  250    continue
  100 continue
 
  999 return
      end
