      subroutine wr_d_rset(numrset,maxref,nfull,nold,maxxnode,rsetref,
     *   rsetbegin,rsetnum,rsetstats,xnode,rsetname,oldname,fullname,
     *   detail,unit)
 
c     Subroutine to write out which regressor sets have been defined
c     and which parameters refer to them.  Also write out spline and
c     dummy transformations of variables.
c
c     Constantijn Panis, 8 July 1996
 
      implicit none
      integer numrset,maxref,nfull,nold,maxxnode,rsetref(maxref),
     *   rsetbegin(numrset),rsetnum(numrset),first,refpos,xnodepntr,
     *   col,width,i,j,n,unit,trm,n1
      double precision rsetstats(5,nfull)
      real xnode(maxxnode),endexprs
      character rsetname(numrset)*12,oldname(nold)*8,fullname(nfull)*8,
     *   name*8
      logical detail
 
      if(numrset.eq.0)goto 999
      refpos=1
      write(unit,101)
      do 100 i=1,numrset
         if(rsetname(i).eq.'(unnamed)')then
            write(unit,102)
         else
            n1=trm(rsetname(i))
            write(unit,103)rsetname(i)(1:n1)
         endif
         call intmatch(0,rsetref(refpos),maxref-refpos+1,n)
         if(n.eq.0)call bug(1,1)
         n=n-1
         if(n.gt.0)then
c           write(unit,'(3x,a,$)')'ref   ='
            write(unit,'(3x,a,$)')'ref   ='
cD           write(unit,'(3x,a)',advance='no')'ref   ='
            call writeints(unit,rsetref(refpos),n,1,0)
            write(unit,'(a)')';'
         endif
         refpos=refpos+n+1
 
Cdefine regressor set  = 'RegSetName';
C   ref = 10 20 45;
C   var = age dummy(educ=1) spline(income, 5 10);
C
C   ---------+-----------------  Summary statistics  ----------------
C   name     |      #        Mean     Std Dev         Min         Max
C   ---------+-------------------------------------------------------
C   age      |   6000      41.976    15.01127        15.0        70.0
C   Union    |   6000        .577     .494035          .0         1.0
C   educ     |   6000       6.039    3.811493          .0        12.0
C   Constant |   6000         1.0          .0         1.0         1.0
 
c        write(unit,'(3x,a,$)')'var ='
         write(unit,'(3x,a,$)')'var ='
cD        write(unit,'(3x,a)',advance='no')'var ='
         col=8
         xnodepntr=mod(rsetbegin(i),maxxnode+1)
  110    width=0
         call writeexpr(100,-1,maxxnode,0,0,0,-xnodepntr,
     *      0,0,0,0,nold,0,0,width,0.,xnode,0.,oldname,0)
         if(col+1+width.gt.72)then
c           write(unit,'(/,a,$)')'         '
            write(unit,'(/,a,$)')'         '
cD          write(unit,'(/,a)',advance='no')'         '
            col=9+width
         else
c           write(unit,'(a,$)')' '
            write(unit,'(a,$)')' '
cD          write(unit,'(a)',advance='no')' '
            col=col+1+width
         endif
         call writeexpr(100,unit,maxxnode,0,0,0,xnodepntr,
     *      0,0,0,0,nold,0,0,width,0.,xnode,0.,oldname,0)
         if(xnode(xnodepntr-1).ne.endexprs())goto 110
         write(unit,'(a)')';'
 
         if(.not.detail)goto 100
         write(unit,104)
         first=rsetbegin(i)/(maxxnode+1)-1
         do 120 j=first+1,first+rsetnum(i)
            name=fullname(j)
            write(unit,'(3x,a8,a2,$)')name,' |'
            n=int(rsetstats(1,j))
c           write(unit,'(i7,$)')n
            write(unit,'(i7,$)')n
cD           write(unit,'(i7)',advance='no')n
            if(n.gt.0)then
               call writedble(unit,rsetstats(2,j),-4,9,0,0)
               if(n.gt.1)call writedble(unit,rsetstats(3,j),-4,9,0,0)
c              if(n.eq.1)write(unit,'(11x,a,$)')'.'
               if(n.eq.1)write(unit,'(11x,a,$)')'.'
cD              if(n.eq.1)write(unit,'(11x,a)',advance='no')'.'
               call writedble(unit,rsetstats(4,j),-4,9,0,0)
               call writedble(unit,rsetstats(5,j),-4,9,0,1)
            else
               write(unit,'(1x)')
            endif
  120    continue
  100 continue
      goto 999
 
  101 format(/,'The following regressor sets have been defined:')
  102 format(/,'define regressor set;')
  103 format(/,'define regressor set ',a,';')
  104 format(/,3x,9('-'),'+',17('-'),'  Summary statistics  ',16('-'),/,
     *   3x,'name',5x,'|',6x,'#',8x,'Mean',5x,'Std Dev',9x,'Min',9x,
     *   'Max',/,3x,9('-'),'+',55('-'))
 
  999 return
      end
