      subroutine wr_d_spl(numspl,maxref,splref,beginspl,numnodes,
     *   nodepos,spltype,maxxnode,unit,originstats,xnode,detail,
     *   splname,fullname,ipt,jpt)
 
c     Subroutine to write out which splines have been defined,
c     which parameters refer to them and what the summary statistics
c     of its origin variables are.
c
c     Constantijn Panis, 8 July 1996
 
      implicit none
      integer numspl,maxref,splref(maxref),unit,beginspl(numspl),
     *   numnodes(numspl),nodepos(numspl),spltype(numspl),maxxnode,
     *   ipt,jpt,refpos,first,last,i,j,num,trm,nt
      double precision originstats(5,numspl)
      real xnode(maxxnode)
      logical detail
      character splname(numspl)*12,fullname(*)*8
 
      if(numspl.eq.0)goto 999
      refpos=1
      write(unit,101)
 
      do 100 i=1,numspl
 
c        Spline reference numbers:
         call intmatch(0,splref(refpos),maxref-refpos+1,num)
         if(num.eq.0)call bug(ipt,jpt)
         num=num-1
c        Spline name and type:
         nt=trm(splname(i))
         if(splname(i).eq.'(unnamed)')then
            if(num.eq.0)call bug(ipt,jpt)
            write(unit,'(/,a)')'define spline;'
         else
            write(unit,'(/,a)')'define spline '//splname(i)(1:nt)//';'
         endif
         if(num.gt.0)call writerefs(unit,num,splref(refpos))
         refpos=refpos+num+1
         first=beginspl(i)
c        Optionally, an intercept?  Write out coefficient name in comment
         if(spltype(i).eq.2.or.spltype(i).eq.4)then
            nt=trm(fullname(first))
            write(unit,'(3x,a)')'intercept;     /* intercept '//
     *         'coefficient: '//fullname(first)(1:nt)//' */'
            first=first+1
         endif
c        Nodes:
c        write(unit,'(3x,a,$)')'nodes ='
         write(unit,'(3x,a,$)')'nodes ='
         do 110 j=nodepos(i),nodepos(i)+numnodes(i)-1
            if(xnode(j).eq.int(xnode(j)))then
               call writeint(unit,int(xnode(j)),1,0)
            else
               call writedble(unit,dble(xnode(j)),1,-8,0,0)
            endif
  110    continue
c        As a comment, write out slope coefficient(s):
         nt=trm(fullname(first))
         if(numnodes(i).eq.0)then
            write(unit,'(a)')';  /* slope coefficient: '//
     *         fullname(first)(1:nt)//' */'
         else
            last=first+numnodes(i)
            write(unit,'(a)')';  /* slope coefficients: '//
     *         fullname(first)(1:nt)//' - '//
     *         fullname(last)(1:trm(fullname(last)))//' */'
         endif
c        Effect option?
         if(spltype(i).eq.3.or.spltype(i).eq.4)write(unit,'(3x,a)')
     *      'effect=right;'
 
c        Summary of origin variable(s):
         if(detail)then
            num=int(originstats(1,i))
            write(unit,107)
c           write(unit,108)num
            write(unit,108)num
cD           write(unit,108,advance='no')num
            if(num.gt.0)then
               call writedble(unit,originstats(2,i),-4,9,0,0)
               if(num.gt.1)call writedble(unit,originstats(3,i),
     *            -4,9,0,0)
c              if(num.eq.1)write(unit,'(11x,a,$)')'.'
               if(num.eq.1)write(unit,'(11x,a,$)')'.'
cD              if(num.eq.1)write(unit,'(11x,a)',advance='no')'.'
               call writedble(unit,originstats(4,i),-4,9,0,0)
               call writedble(unit,originstats(5,i),-4,9,0,1)
            else
               write(unit,'(1x)')
            endif
         endif
  100 continue
      goto 999
 
  101 format(/,'The following splines have been defined:')
  107 format(/,3x,9('-'),'+',17('-'),'  Summary statistics  ',16('-'),/,
     *   12x,'|',6x,'#',8x,'Mean',5x,'Std Dev',9x,'Min',9x,'Max',/,
     *   3x,9('-'),'+',55('-'))
c 108 format(3x,'origin   |',i7,$)
  108 format(3x,'origin   |',i7,$)
cD 108 format(3x,'origin   |',i7)
 
  999 return
      end
 
