      subroutine wr_m_par(unit,nfull,numpar,levelmax,moel,meno,pardim,
     *   parpos,namepntr,maxxnode,nold,xnode,parname,oldname)
 
c     Subroutine to write out a parameter reference in any
c     particular model statement.
c
c     moel(*) contains input information:
c     moel(1) = 2 this is a parameter
c     moel(2) = 1 reference is direct;
c               2 reference is direct of (inverse) matrix element
c               3 reference is indirect
c     moel(3)  = parameter rank number if moel(2)=1
c                parameter location (may be >nfull) if moel(2)=2
c                expression position in xnode if moel(2)=3
c
c     Constantijn Panis, 14 January 1998
c     Last change:  expression machinery
 
      implicit none
      integer unit,nfull,numpar,levelmax,moel(*),meno,
     *   pardim(numpar),parpos(numpar),namepntr(levelmax),maxxnode,nold,
     *   loc,dim1,i,i1,i2,trm
      real xnode(maxxnode)
      character parname(*)*12,oldname(nold)*8,name*12
 
      if(moel(meno+1).eq.1)then
c        Directly referenced scalar or vector
         name=parname(moel(meno+2))
c        write(unit,'(a,$)')'par '//name(1:trm(name))
         write(unit,'(a,$)')'par '//name(1:trm(name))
cD        write(unit,'(a)',advance='no')'par '//name(1:trm(name))
      elseif(moel(meno+1).eq.2)then
c        Directly referenced (inverse) matrix element.
         loc=moel(meno+2)
         if(loc.le.nfull)then
c           Matrix element.  Figure out of which matrix:
            do 100 i=1,numpar
               if(parpos(i).gt.loc)goto 110
  100       continue
  110       i=i-1
c           Figure out which element:
            dim1 = abs(pardim(i))/nfull
            loc=loc-parpos(i)+1
            i1=mod(loc-1,dim1)+1
            i2=(loc-1)/dim1+1
            name=parname(i)
            call writea2ia(unit,72,0,'par '//name(1:trm(name))//
     *         '(',i1,',',i2,')')
         else
c           Element of inverse matrix.  Figure out of which matrix:
            loc=loc-nfull
            do 120 i=1,numpar
               loc=loc-(abs(pardim(i))/nfull)*mod(abs(pardim(i)),nfull)
               if(loc.le.0)goto 130
  120       continue
  130       continue
c           Figure out which element:
            loc=loc+(abs(pardim(i))/nfull)*mod(abs(pardim(i)),nfull)
            dim1 = abs(pardim(i))/nfull
            i1=mod(loc-1,dim1)+1
            i2=(loc-1)/dim1+1
            name=parname(i)
            call writea2ia(unit,72,0,'par inv('//name(1:trm(name))//
     *         '(',i1,',',i2,'))')
         endif
      elseif(moel(meno+1).eq.3)then
c        Indirectly referenced:
c        write(unit,'(a,$)')'par(refvar='
         write(unit,'(a,$)')'par(refvar='
cD        write(unit,'(a)',advance='no')'par(refvar='
         call writeexpr(100,unit,maxxnode,0,levelmax,1,-moel(meno+2),
     *      0,0,0,0,nold,0,namepntr,-1,0.,xnode,0.,oldname,0)
c        write(unit,'(a,$)')')'
         write(unit,'(a,$)')')'
cD        write(unit,'(a)',advance='no')')'
      endif
      meno=meno+3
 
      return
      end
