      subroutine wr_m_res(unit,levelmax,numdist,sumdim,moel,meno,
     *   namepntr,maxxnode,nold,distdim,xnode,resname,oldname)
 
c     Subroutine to write out a non-integrated residual reference.
c        moel(1) = 4  This is a integrated residual;
c                  7  this is a non-integrated residual
c        moel(2) = 1  draw is given by expression
c                  2  draw is _leveln
c                  3  draw is _iid
c                  4  residual(draw=_iid, ref=N(0,1)) (see read_model4)
c        moel(3) = position in xnode where expression starts if moel(2)=1
c                  level if moel(2)=2
c                  n/a if moel(2)=3
c        moel(4) = 1  residual is directly referenced
c                  2  residual is indirectly referenced
c        moel(5) = distribution rank number if moel(4)=1
c                  expression position in xnode if moel(4)=2
c        moel(6) = dimension rank number if moel(4)=1
c                  n/a if moel(4)=2
c
c     Constantijn Panis, 12 September 1998
c     Last change: draw=_iid
 
      implicit none
      integer unit,levelmax,numdist,sumdim,distdim(numdist),
     *   moel(*),meno,namepntr(levelmax),maxxnode,
     *   nold,level,dist,dim,n,trm,intvecsum
      real xnode(maxxnode)
      character resname(sumdim)*12,oldname(nold)*8
 
      if(moel(meno).eq.4)then
c        write(unit,'(a,$)')'intres(draw='
         write(unit,'(a,$)')'intres(draw='
cD        write(unit,'(a)',advance='no')'intres(draw='
      elseif(moel(meno).eq.7)then
c        write(unit,'(a,$)')'res(draw='
         write(unit,'(a,$)')'res(draw='
cD        write(unit,'(a)',advance='no')'res(draw='
      else
         call bug(1,1)
      endif
 
      if(moel(meno+1).eq.1)then
         call writeexpr(100,unit,maxxnode,0,levelmax,1,-moel(meno+2),
     *      0,0,0,0,nold,0,namepntr,-1,0.,xnode,0.,oldname,0)
c        write(unit,'(a,$)')', '
         write(unit,'(a,$)')', '
cD        write(unit,'(a)',advance='no')', '
      elseif(moel(meno+1).eq.2)then
         level=moel(meno+2)
         call writeaia(unit,0,0,'_level',level,', ')
      elseif(moel(meno+1).eq.3)then
c        write(unit,'(a,$)')'_iid, '
         write(unit,'(a,$)')'_iid, '
cD        write(unit,'(a)',advance='no')'_iid, '
      elseif(moel(meno+1).eq.4)then
c        IID(0,1) residual
c        write(unit,'(a,$)')'_iid, ref=N(0,1))'
         write(unit,'(a,$)')'_iid, ref=N(0,1))'
cD        write(unit,'(a)',advance='no')'_iid, ref=N(0,1))'
         meno=meno+2
         goto 999
      else
         call bug(1,1)
      endif
 
      if(moel(meno+3).eq.1)then
c        Directly referenced:
         dist=moel(meno+4)
         dim=intvecsum(distdim,dist-1)+moel(meno+5)
         n=trm(resname(dim))
c        write(unit,'(a,$)')'ref='//resname(dim)(1:n)//')'
         write(unit,'(a,$)')'ref='//resname(dim)(1:n)//')'
cD        write(unit,'(a)',advance='no')'ref='//resname(dim)(1:n)//')'
         meno=meno+6
      elseif(moel(meno+3).eq.2)then
c        Indirectly referenced:
c        write(unit,'(a,$)')'refvar='
         write(unit,'(a,$)')'refvar='
cD        write(unit,'(a)',advance='no')'refvar='
         call writeexpr(100,unit,maxxnode,0,levelmax,1,-moel(meno+4),
     *      0,0,0,0,nold,0,namepntr,-1,0.,xnode,0.,oldname,0)
c        write(unit,'(a,$)')')'
         write(unit,'(a,$)')')'
cD        write(unit,'(a)',advance='no')')'
         meno=meno+5
      else
         call bug(1,1)
      endif
 
  999 return
      end
