      subroutine wrapint(unit,col,width,lf,intvar)
 
c     Subroutine to neatly write out an integer, wrapping
c     whenever column width is exceeded.  Arguments:
c        unit [in] unit number to which to write
c        col  [in/out] Upon input, column where first character will
c                  end up (important for comparison to width);  upon
c                  output, column where any subsequent write statement
c                  will start writing.
c        width [in] number of columns to be used in writing; if <=0,
c                   no wrapping is done.
c        lf    [in] if =0, no linefeed is written out after integer;
c                   else, linefeed will be written out.
c        intvar [in] integer to be written
c
c     Note:  this routine is mainly intended to be called by subroutines
c     writeaia, writea2ia, writea3ia, and writea4ia.
c
c     Constantijn Panis, 7 June 1996
 
      implicit none
      integer unit,col,width,lf,intvar,num,intlen
 
      num=intlen(intvar)
      if(width.le.0.or.col+num-1.lt.width)then
         call writeint(unit,intvar,0,lf)
         col=col+num
      elseif(col+num-1.eq.width)then
         call writeint(unit,intvar,0,1)
         col=1
      elseif(col+num-1.gt.width)then
         write(unit,'(1x)')
         call writeint(unit,intvar,0,lf)
         col=num+1
      endif
 
      if(lf.ne.0)col=1
 
      return
      end
