      subroutine writefileline(unit,ipt,jpt)
 
c     Subroutine to write out a clarifying error message with the last
c     line read from the file connected to unit, including the name of the
c     file.  For example:
c
c     The error was found in or very near to the following line in
c     file 'abc.ctl':
c     This is the last line in abc.ctl
c
c     Note the existence of writeline, which does not write out the
c     name of the file connected to unit.
c
c     Constantijn Panis, 1 July 1996
 
      implicit none
      integer unit,ipt,jpt,trm
      character line*256
 
      inquire(unit=unit,name=line)
      if(ipt.gt.0)write(8,101)line(1:trm(line))
      if(jpt.gt.0)write(6,101)line(1:trm(line))
  101 format(/,'The error was found in or very near to the following ',
     *   'line in',/,'file ''',a,''':')
      backspace unit
      read(unit,'(a256)',err=999)line
      if(ipt.gt.0)write(8,'(a)')line(1:trm(line))
      if(jpt.gt.0)write(6,'(a)')line(1:trm(line))
 
  999 return
      end
