      subroutine writeline(unit1,unit2,il)
 
c     Subroutine to write out a line and place a caret (^) underneath
c     the place where an error is suspected.  If il<0, nothing is
c     written out.  If il=0, the line is written out, but not the caret.
c     A blank line is always written out first.
c
c     Note the existence of writefileline, which also writes out the
c     name of the file connected to unit1.
c
c     Also note the existence of caretline, which does the same as
c     writeline, but requires character*80 line to be passed in.
c
c     Constantijn Panis, 20 May 1997
c     Last change:  only write out line and caret, no other text.
 
      implicit none
      integer unit1,unit2,il,trm
      character line*128,fmt*8,i2c*12
 
      if(il.lt.0)goto 999
      backspace unit1
      read(unit1,'(a128)',err=999)line
      write(unit2,'(/,a)')line(1:trm(line))
 
      if(il.eq.0)goto 999
      fmt='('//i2c(il-1,0)
      fmt=fmt(1:trm(fmt))//'x,a)'
      write(unit2,fmt)'^'
 
  999 return
      end
