      subroutine writelt(title,dim,names,matrix,entries,format,unit)
 
c     Subroutine to print the lower triangle of a symmetric
c     matrix.  The input matrix need not be "filled" completely:
c     only ((x(i,j),j=1,i),i=1,n) is used.
c     The matrix is assumed to be double precision and of order
c     n by n.  A vector of 8 character names is used to label the rows
c     and columns of the matrix and a title is printed at the top.
c
c     title   [in]  title to be printed on top
c     dim     [in]  matrix is dim by dim
c     names   [in]  vector of row/column names
c     matrix  [in]  double precision matrix(dim,dim)
c     entries [in]  number of entries per row (5 works best)
c     format  [in]  format for number printing (1=1pe11.3  2=f11.4)
c     unit    [in]  unit to write to
c
c     Note: this routine was derived from vrpint (2 Jan 1991).
c
c     Constantijn Panis, 9 July 1995
 
      implicit none
      integer dim,format,entries,unit,ii,j,k,nlong,len,trm
      double precision matrix(dim,dim)
      character title*(*),names(dim)*8,fmt1*18,fmt2*18,i2c*12
 
      ii=(72-len(title))/2
      fmt1='(/,'//i2c(ii,0)
      fmt1=fmt1(1:trm(fmt1))//'x,a)'
      write(unit,fmt1)title
      fmt2='(a8,2x,1p,5e11.3)'
      if(format.eq.2)fmt2='(a8,5f11.4)'
 
c     ii counts block number, nlong is number of elements on a line
      ii=1
  100 nlong = min(entries,dim-(ii-1)*entries)
      fmt1='(/,9x,'//i2c(nlong,0)
      fmt1=fmt1(1:trm(fmt1))//'a11,/)'
      write(unit,fmt1)(names(k+(ii-1)*entries),k=1,nlong)
      do 110 j=1+(ii-1)*entries,dim
         write(unit,fmt2)names(j),(matrix(j,k+(ii-1)*entries),
     *      k=1,min(nlong,j-(ii-1)*entries))
  110 continue
      if(ii*entries.ge.dim)goto 999
      ii=ii+1
      write(unit,'(1x)')
      goto 100
  999 return
      end
 
 
