      subroutine writestart(ngrid,nfull,iiffull,fullname,grid,fullbeta,
     *   gridpos,fulltype,gridfile,ipt,jpt)
 
c     Subroutine to print out number of model parameters, number of
c     parameters to be estimated, and starting values of the parameters.
c
c     Constantijn Panis, 27 August 2002
c     Last change: grid searches
 
      implicit none
      integer ngrid,nfull,nfree,ipt,jpt,gridpos(ngrid,2),
     *   fulltype(nfull),iiffull(nfull),unit,
     *   i,j,n,dim,factor,igrid,intvecmax,trm
      double precision grid(ngrid,2),fullbeta(nfull)
      character fullname(nfull)*8,gridfile*128,tf*8
 
c     How many estimation rounds?  See read_seed:  a sequence like FFT is
c     coded as binary 100 (decimal 4); TTFT is binary 1011 (decimal 11).
      n=int(log(real(intvecmax(iiffull,nfull))+.5)/log(2.))+1
 
      unit=8
      if(ipt.lt.4)goto 220
c 100 write(unit,101)nfull
c 101 format(/,70('='),//,'Number of parameters in model:',i9,/,
c    *   'Number of parameters estimated:    ',$)
  100 write(unit,101)nfull
  101 format(/,70('='),//,'Number of parameters in model:',i9,/,
     *   'Number of parameters estimated:    ',$)
cD 100 write(unit,101,advance='no')nfull
cD 101 format(/,70('='),//,'Number of parameters in model:',i9,/,
cD    *   'Number of parameters estimated:    ')
      factor=1
  110 nfree=0
      do 120 i=1,nfull
         if(mod(iiffull(i)/factor,2).eq.1)nfree=nfree+1
  120 continue
      if(nfree.eq.0)goto 130
c     if(factor.eq.1)write(unit,'(i4,$)')nfree
      if(factor.eq.1)write(unit,'(i4,$)')nfree
cD     if(factor.eq.1)write(unit,'(i4)',advance='no')nfree
c     if(factor.gt.1)write(unit,'(a,i4,$)')';',nfree
      if(factor.gt.1)write(unit,'(a,i4,$)')';',nfree
cD     if(factor.gt.1)write(unit,'(a,i4)',advance='no')';',nfree
      factor=2*factor
      goto 110
  130 write(unit,131)
  131 format(//,'Starting values:',/,5x,'Name      Est?     Value')
 
      dim=0
      igrid=1
      do 200 i=1,nfull
         tf='FFFFFFFF'
         do 210 j=1,n
            if(mod(iiffull(i)/(2**(j-1)),2).eq.1)tf(j:j)='T'
  210    continue
         write(unit,201)i,fullname(i),tf(1:n)
         if(igrid.le.ngrid)then
            if(gridpos(igrid,1).eq.i)then
               call writea2da(unit,72,0,'     grid(',-8,grid(igrid,1),
     *            ', ',-8,grid(igrid,2),',')
               call writeaia(unit,72,0,' ',gridpos(igrid,2),')')
               igrid=igrid+1
            else
               write(unit,202)fullbeta(i)
            endif
         else
            write(unit,202)fullbeta(i)
         endif
         if(fulltype(i).eq.0.or.fulltype(i).eq.41)then
            if(dim.eq.0)then
               write(unit,'(1x)')
            else
c              Preceding dim parameters were fulltype=5, i.e., standard
c              deviations of a distribution that is Cholesky-searched.
               if(dim.gt.0)dim=-(dim*(dim-1))/2
               write(unit,'(4x,a)')'(must be between -1 and 1)'
               dim=dim+1
            endif
         elseif(fulltype(i).eq.1)then
            write(unit,'(4x,a)')'(must be strictly positive)'
         elseif(fulltype(i).eq.2)then
            write(unit,'(4x,a)')'(must be between -1 and 1)'
         elseif(fulltype(i).eq.3)then
            write(unit,'(4x,a)')'(must be between 0 and 1)'
         elseif(fulltype(i).eq.4.or.fulltype(i).gt.100)then
            write(unit,203)fullname(i-1)(1:trm(fullname(i-1)))
         elseif(fulltype(i).eq.5)then
            write(unit,'(4x,a)')'(must be strictly positive)'
            dim=dim+1
         endif
  201    format(i3,a10,3x,a,$)
  202    format(f14.6,$)
  203    format(4x,'(must be larger than ',a,')')
  200 continue
  220 if(unit.eq.6.or.jpt.lt.4)goto 999
      unit=6
      goto 100
 
  999 return
      end
