      subroutine wrmodel(levelmax,unit,nfull,numdist,sumdim,numpar,meno,
     *   moel,maxxnode,distdim,pardim,parpos,namepntr,nold,xnode,
     *   oldname,parname,rsetname,resname,splname)
 
c     General subroutine to write out a model specification.
c     This routine currently handles parameters, regressor sets,
c     integrated residuals, duration splines and regressor splines.
c
c     Constantijn Panis, 6 September 2002
c     Last change: variables allowed
 
      implicit none
      integer levelmax,unit,nfull,numdist,sumdim,numpar,meno,moel(*),
     *   maxxnode,distdim(numdist),pardim(numpar),parpos(numpar),
     *   namepntr(levelmax),nold,termtype,numterm,varpos,level,trm
      real xnode(maxxnode)
      character oldname(nold)*8,parname(*)*12,rsetname(*)*12,
     *   resname(sumdim)*8,splname(*)*12,name*8
      logical first
 
      first=.true.
 
  100 if(moel(meno).eq.-99)then
c        End of model (or part of model) specification:
         meno=meno+1
         goto 999
      elseif(moel(meno).lt.0)then
c        Next model element:
         termtype=moel(meno)
         meno=meno+1
         if(termtype.eq.-3.or.termtype.eq.-4.or.termtype.eq.-5.or.
     *      termtype.eq.-7)then
            numterm=moel(meno)
            meno=meno+1
         else
            call bug(1,1)
         endif
         if(first)then
            if(numterm.lt.0)then
               numterm=-numterm
c              write(unit,'(a,$)')' -'
               write(unit,'(a,$)')' -'
cD              write(unit,'(a)',advance='no')' -'
            endif
            first=.false.
         elseif(numterm.gt.0)then
c           write(unit,'(a,/,a,$)')' +','      '
            write(unit,'(a,/,a,$)')' +','      '
cD           write(unit,'(a,/,a)',advance='no')' +','      '
         elseif(numterm.lt.0)then
            numterm=-numterm
c           write(unit,'(a,/,a,$)')' -','      '
            write(unit,'(a,/,a,$)')' -','      '
cD           write(unit,'(a,/,a)',advance='no')' -','      '
         endif
         goto 100
      elseif(moel(meno).eq.2)then
c        Parameter:
         call wr_m_par(unit,nfull,numpar,levelmax,moel,meno,pardim,
     *      parpos,namepntr,maxxnode,nold,xnode,parname,oldname)
      elseif(moel(meno).eq.3)then
c        Regressor set:
         call wr_m_rset(unit,levelmax,moel,meno,namepntr,maxxnode,
     *      nold,xnode,rsetname,oldname)
      elseif(moel(meno).eq.4.or.moel(meno).eq.7)then
c        Non-integrated residual:
         call wr_m_res(unit,levelmax,numdist,sumdim,moel,meno,namepntr,
     *      maxxnode,nold,distdim,xnode,resname,oldname)
      elseif(moel(meno).eq.5.or.moel(meno).eq.8)then
c        Duration or regressor spline:
         call wr_m_spl(unit,levelmax,moel,meno,maxxnode,nold,
     *      namepntr,xnode,splname,oldname)
      elseif(moel(meno).eq.9)then
c        Variable:
         varpos=moel(meno+1)
         meno=meno+2
         level=varpos/(nold+1)
         varpos=mod(varpos,nold+1)
         name=oldname(namepntr(level)+varpos-1)
c        write(unit,'(a,$)')name(1:trm(name))
         write(unit,'(a,$)')name(1:trm(name))
cD        write(unit,'(a)',advance='no')name(1:trm(name))
      else
         call bug(1,1)
      endif
      if(numterm.ge.2)then
c        write(unit,'(a,$)')' * '
         write(unit,'(a,$)')' * '
cD        write(unit,'(a)',advance='no')' * '
         numterm=numterm-1
      elseif(moel(meno).eq.-99)then
c        End of model (or part of model) specification.  Note that
c        no semicolon and no linefeed is written.
         meno=meno+1
         goto 999
      endif
      goto 100
 
  999 return
      end
