      integer function xpos(level,nbdim,nb,branch,xpntr,nxold,varpos)
 
c     Integer function that returns the relevant position in data vector
c     x of the current branch at level level.  Arguments:
c        level  [in] level of variable of which position needs to be found
c        nbdim  [in] dimension of nb
c        nb     [in] array containing numbers of branches
c        branch [in] current branch
c        xpntr  [in] pointers just before first variable for each level
c        nxold  [in] number of variables, each level
c        varpos [in] variable number (within data structure and level)
c
c     Constantijn Panis, 16 July 1996
 
      implicit none
      integer level,nbdim,nb(nbdim,2),branch(level),
     *   xpntr(2:level),nxold(level),varpos,n,absbranch
 
      if(level.eq.1)then
         xpos=varpos
      elseif(level.eq.2)then
         xpos=xpntr(2)+varpos
      else
         n=absbranch(level,branch,nbdim,nb)
         xpos=xpntr(level)+nxold(level)*(n-1)+varpos
      endif
 
      return
      end
