      subroutine crossstats(levelmax,datadim,nvar,nx,namepntr,datalevel,
     *   xbase,double,xmean,xstd,xmin,xmax,name,varywarn)
 
c     Some variables may appear in multiple data structures.  The
c     summary statistics of these variables need to be computed
c     across all data structures, and deviations from means need to
c     be based on the grand means.  This default can be overruled
c     by "CROSSMEANS = no;" in the control file.
c     Note: the original (within data structure) summary statistics
c     are destroyed in this routine.
c
c     Constantijn Panis, 12 June 1996
 
      implicit none
      integer levelmax,datadim,nvar,nx(levelmax,datadim),
     *   namepntr(levelmax,datadim),datalevel(datadim),
     *   xbase(nvar),double(nvar),level,dim,i,j,n,numvar
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar),
     *   mean,std,minimum,maximum
      character name(nvar)*8,varywarn*8
      varywarn='(((())))'
 
c     Level 1 variables cannot appear in multiple data structures.
c     Level 2+ variables:
      do 100 dim=1,datadim
         do 110 level=2,datalevel(dim)
            numvar = nx(level,dim)
            if(level.eq.2)numvar=numvar+1
            do 120 i=namepntr(level,dim),namepntr(level,dim)+numvar-1
c              Only keep the first occurrence of a double:
               if(double(i).ne.i)goto 120
               call crossinfo(levelmax,datadim,nvar,nx,namepntr,
     *            datalevel,xbase,xmean,xstd,xmin,xmax,name(i),name,
     *            n,mean,std,minimum,maximum,varywarn)
               do 130 j=i,nvar
                  if(double(j).ne.i)goto 130
                  xbase(j) = n
                  xmean(j) = mean
                  xstd(j) = std
                  xmin(j) = minimum
                  xmax(j) = maximum
  130          continue
  120       continue
  110    continue
  100 continue
 
      return
      end
