      subroutine deductwhat(levelmax,datadim,nvar,nx,namepntr,datalevel,
     *   xbase,double,xmean,xstd,xmin,xmax,deduct,name,cross)
 
c     Subroutine to figure out what will be deducted from variables:
c        zero if the variable is in absolute value;
c        the mean if deviations from means are taken;
c        the mean across data structures if such is desired;
c        a user-specified constant.
c
c     Constantijn Panis, 5 July 1996
 
      implicit none
      integer levelmax,datadim,nvar,nx(levelmax,datadim),
     *   namepntr(levelmax,datadim),datalevel(datadim),
     *   xbase(nvar),double(nvar),i,j,n,numvar,level,dim
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar),
     *   mean,std,minimum,maximum
      real deduct(nvar),deductflag
      character name(nvar)*8,varywarn
      logical cross
 
c     First deal with level 1 variables:
      do 100 i=3,2+nx(1,1)
         if(deduct(i).ne.deductflag())goto 100
         deduct(i) = real(xmean(i))
  100 continue
 
c     Then deal with level 2+ variables.  These are far more complicated,
c     because cross-data structure means may need to be computed.
      do 200 dim=1,datadim
         do 210 level=1,datalevel(dim)
            numvar = nx(level,dim)
            if(level.eq.2)numvar=numvar+1
            do 220 i=namepntr(level,dim),namepntr(level,dim)+numvar-1
c              If deduct(i) is zero or some user-defined constant,
c              then that number needs to be deducted.  If deduct(i)
c              is deductflag(), the mean needs to be deducted.
               if(deduct(i).ne.deductflag())goto 220
c              Deduct the mean.  Within data structure mean?
               if(.not.cross.or.double(i).ne.i)then
                  deduct(i) = real(xmean(i))
                  goto 220
               endif
c              This variable appears in multiple data structures.  Its mean
c              across data structures needs to be computed and deducted.
               call crossinfo(levelmax,datadim,nvar,nx,namepntr,
     *            datalevel,xbase,xmean,xstd,xmin,xmax,name(i),name,
     *            n,mean,std,minimum,maximum,varywarn)
               deduct(i)=real(mean)
               do 230 j=i+1,nvar
                 if(double(j).eq.i.and.deduct(j).eq.deductflag())
     *              deduct(j)=deduct(i)
  230          continue
  220       continue
  210    continue
  200 continue
 
      return
      end
