      integer function dimnb(level,nb)
 
c     Integer function to compute the dimension of nb if there are level
c     levels.
c     Input array nb is built up as follows:
c        nb(1) = number of level 3 branches
c        nb(2) = number of level 4 branches from the first level 3 branch
c        nb(3) = number of level 4 branches from the second level 3 branch
c        nb(nb(1)+1) = number of level 4 branches from the last level 3 branch
c        nb(nb(1)+2) = number of level 5 branches from the first level 4 branch
c                            from the first level 3 branch
c        etc.
c
c     Constantijn Panis, 2 July 1996
 
      implicit none
      integer level,nb(*),pntr,n1,n2,i,intvecsum
 
      if(level.eq.2)then
         dimnb=0
      elseif(level.eq.3)then
         dimnb=1
      else
         pntr=1
         n1=1
         n2=1
         do 100 i=3,level
            n2=intvecsum(nb(pntr),n1)
            pntr=pntr+n1
            n1=n2
  100    continue
         dimnb=pntr-1
      endif
 
      return
      end
