      subroutine figure_pntr(nb2,levelmax,datadim,maxnbdim,xpntr,nx,
     *   datalevel,nb,ds)
 
c     Subroutine to figure out pointers to locations in the data
c     vector JUST BEFORE where variables of level 2 and higher begin.
c     there is one set of pointers for each level 2 branch.  There may be
c     multiple level 3 and lower branches; the pointer points at the
c     very first variable of that level.  Subsequent positions are
c     straightforward to determine, because the number of variables
c     is known readily.
c
c     Constantijn Panis,  4 July 1996
 
      implicit none
      integer nb2,levelmax,datadim,maxnbdim,xpntr(2:levelmax,nb2),
     *   nx(levelmax,datadim),datalevel(datadim),nb(maxnbdim,nb2),
     *   ds(nb2),posx,ib2,num,level,numbranch
 
      if(levelmax.eq.1)goto 999
 
c     Note that _id and _one are not counted in nx(1,1)
      posx=nx(1,1)+2
 
      do 100 ib2=1,nb2
         xpntr(2,ib2)=posx
c        One extra for the data check, which is not in nx(2,.)
         posx=posx+1+nx(2,ds(ib2))
         do 110 level=3,datalevel(ds(ib2))
            xpntr(level,ib2)=posx
c           How many level level branches are there in this level 2 branch?
            num=numbranch(level,nb(1,ib2))
            posx=posx+nx(level,ds(ib2))*num
  110    continue
  100 continue
 
  999 return
      end
