      integer function numcompx(level,nx,nb)
 
c     Integer function to compute the number of variable values to be read
c     of branches up to and including level level if the data are stored
c     in compressed format.  Level 1 variables are included.
c     Input array nb is built up as follows:
c        nb(1) = number of level 3 branches
c        nb(2) = number of level 4 branches from the first level 3 branch
c        nb(3) = number of level 4 branches from the second level 3 branch
c        nb(nb(1)+1) = number of level 4 branches from the last level 3 branch
c        nb(nb(1)+2) = number of level 5 branches from the first level 4 branch
c                            from the first level 3 branch
c        etc.
c     Integer array nx denotes the number of variables at each level for
c     the current data structure.
c
c     Constantijn Panis, 17 November 2000
c     Last change: Include level 1 variables.
 
      implicit none
      integer level,nx(level),nb(*),pntr,n1,n2,n3,i,intvecsum
 
      if(level.eq.1)then
         n3=nx(1)
      elseif(level.eq.2)then
         n3=nx(1)+nx(2)
      elseif(level.eq.3)then
         n3=nx(1)+nx(2)+nb(1)*nx(3)
      else
         n3=nx(1)+nx(2)
         pntr=1
         n1=1
         n2=1
         do 100 i=3,level
            n2=intvecsum(nb(pntr),n1)
            pntr=pntr+n1
            n1=n2
            n3=n3+nx(i)*n2
  100    continue
      endif
      numcompx=n3
 
      return
      end
