      subroutine read_option(maxobs,maxnb2,maxxdim,maxnbdim,
     *   deviations,irrelcheck,irrelvalue,cross,line,il)
 
c     Subroutine to read in options.  Currently supported options are:
c        OPTION OUTPUT DATA FILE = filename.dat [(REPLACE={yes|no})];
c        OPTION DEVIATIONS;
c        OPTION OBServations = n;
c        OPTION IRRELEVANCE CHECK [={yes|no|n}] ;
c        OPTION CROSSMEANS [={yes|no}] ;
c        OPTION MAXimum NUMber of LEVEL 2 BRANCHES = n;
c        OPTION MAXimum DATA SPACE = n;
c        OPTION MAXimum BRANCH SPACE = n;
c
c     Constantijn Panis, 24 January 2000
c     Last change: yes/no syntax changed
 
      implicit none
      integer maxobs,maxnb2,maxxdim,maxnbdim,irrelvalue,il,previl,flag,
     *   status
      character line*128
      logical deviations,irrelcheck,cross,smtxt,opened
 
      if(smtxt(4,line,il,'DEViations'))then
c        Default is no; deduct has been initialized to zero.
         call semiyesno(flag,4,line,il,-1,1)
         deviations=(flag.eq.1)
      elseif(smtxt(4,line,il,'OBServations='))then
c        Default is all (-1)
         if(smtxt(4,line,il,'ALL;'))goto 999
         call getint(4,maxobs,line,il,status)
         if(status.gt.0)goto 800
         if(maxobs.lt.0)goto 800
         if(.not.smtxt(4,line,il,';'))goto 800
      elseif(smtxt(4,line,il,'IRRELEVANCE'))then
         if(smtxt(4,line,il,'_'))continue
         if(.not.smtxt(4,line,il,'CHECK'))goto 800
c        Default is -99
         if(smtxt(4,line,il,';').or.smtxt(4,line,il,'=YES;'))then
            irrelvalue=-99
            irrelcheck=.true.
         elseif(smtxt(4,line,il,'=NO;'))then
            irrelcheck=.false.
         elseif(smtxt(4,line,il,'='))then
            call getint(4,irrelvalue,line,il,status)
            if(status.gt.0)goto 800
            irrelcheck=.true.
            if(.not.smtxt(4,line,il,';'))goto 800
         else
            goto 800
         endif
      elseif(smtxt(4,line,il,'CROSSMEANS'))then
c        Default is yes
         call semiyesno(flag,4,line,il,-1,1)
         cross=(flag.eq.1)
      elseif(smtxt(4,line,il,'MAXimum NUMber of LEVEL 2 BRANCHES ='))
     *   then
         previl=il
         call getint(4,maxnb2,line,il,status)
         if(status.gt.0)goto 820
         if(.not.smtxt(4,line,il,';'))goto 800
      elseif(smtxt(4,line,il,'MAXimum DATA SPACE ='))then
         previl=il
         call getint(4,maxxdim,line,il,status)
         if(status.gt.0)goto 820
         if(.not.smtxt(4,line,il,';'))goto 800
      elseif(smtxt(4,line,il,'MAXimum BRANCH SPACE ='))then
         previl=il
         call getint(4,maxnbdim,line,il,status)
         if(status.gt.0)goto 820
         if(.not.smtxt(4,line,il,';'))goto 800
      elseif(smtxt(4,line,il,'OUTPUT DATA FILE ='))then
c        Already processed in subroutine outputfile.
         call gotochar(4,';',line,il,status)
         if(status.gt.0)goto 800
      elseif(smtxt(4,line,il,'BEEP'))then
c        Used to be an option; ignore now.
         call semiyesno(flag,4,line,il,-1,1)
      else
         goto 800
      endif
      goto 999
 
  800 if(opened(8))write(8,801)line
      write(6,801)line
  801 format(/,'ERROR encountered in OPTION statement.  The correct ',
     *   'syntax is',/,
     *   6x,'option output data file = filename.dat [(replace)];',/,
     *   6x,'option deviations;',/,
     *   6x,'option observations=n;',/,
     *   6x,'option irrelevance check [={yes|no|n}] ;',/,
     *   6x,'option crossmeans=no;',/,
     *   6x,'option maximum number of level 2 branches=n;',/,
     *   6x,'option maximum data space=n;',/,
     *   6x,'option maximum branch space=n;',//,
     *   'Last line read:',//,a)
      stop
  820 il=min(il,previl)
      if(opened(8))then
         call caretline(8,line,il)
         write(8,821)
      endif
      call caretline(6,line,il)
      write(6,821)
  821 format('ERROR: positive integer expected.')
      stop
  999 return
      end
