      subroutine read_r2a(numvar,datadim,levelmax,datastructure,
     *   datalevel,nbr,double,nx,nx1,namepntr,nfiles,
     *   deduct,rect,deviations,irrelcheck,withid,
     *   cross,name,line,il)
 
      implicit none
      integer numvar,datadim,levelmax,datastructure(datadim),
     *   datalevel(datadim),nbr(levelmax,datadim),
     *   double(numvar),rect(datadim),
     *   nx(levelmax,datadim),nx1,namepntr(levelmax,datadim),
     *   nfiles,dd,il,level,nvar,
     *   prevlevel,match,dim,next,i,status,intvecmin,intvecmax
      real deduct(numvar)
      logical deviations,irrelcheck,
     *   withid,cross,smtxt,realallzero,iseof
      character name(numvar)*8,line*128
 
      nfiles=0
      nvar=2
      if(levelmax.eq.1)call putint(1,datalevel,datadim)
      prevlevel=0
      dd=0
      rewind 4
      read(4,'(a80)',end=800,err=800)line
      il=1
 
  100 if(smtxt(4,line,il,'ID FILE='))then
         call idfile(withid,line,il)
      elseif(smtxt(4,line,il,'ASCII DATA FILEs='))then
         call asciifiles(nfiles,line,il)
      elseif(smtxt(4,line,il,'OUTPUT DATA FILE='))then
c        Already taken care of in scanr2a:
         call gotochar(4,';',line,il,status)
         if(status.gt.0)goto 800
      elseif(smtxt(4,line,il,'OPTIONs'))then
c        Options were read in scanr2a:
         call gotochar(4,';',line,il,status)
         if(status.gt.0)goto 800
      else
         goto 200
      endif
      goto 100
 
  200 if(smtxt(4,line,il,'LEVEL'))then
c        LEVEL n VAR [(nb=n)] = ...;
         call getint(4,level,line,il,status)
         if(status.gt.0)goto 830
         if(level.lt.1)goto 830
         if(level.le.prevlevel)goto 850
         if(level.eq.1.and.dd.ne.0)goto 820
         if(level.gt.1.and.dd.eq.0)dd=1
         if(.not.smtxt(4,line,il,'VARiables'))goto 820
         if(smtxt(4,line,il,'(NB='))then
c           Data are rectangular with nb branches
            if(level.le.2)goto 810
            if(rect(dd).eq.-1)goto 860
            if(level.gt.3.and.intvecmin(nbr(3,dd),level-3).le.0)goto 860
            rect(dd)=1
            call getint(4,nbr(level,dd),line,il,status)
            if(status.gt.0)goto 830
            if(nbr(level,dd).le.0)goto 830
            if(.not.smtxt(4,line,il,')'))goto 820
         elseif(level.ge.3)then
            if(rect(dd).eq.1)goto 860
            rect(dd)=-1
         endif
         if(.not.smtxt(4,line,il,'='))goto 820
         if(level.eq.1)then
            if(nx(1,1).ne.0)goto 820
            call varlist(numvar,nvar,nx(1,1),deduct,name,line,il)
            nx1=nx(1,1)
         else
            if(nx(level,dd).ne.0)goto 820
c           The first level 2 variable is always _branch2, which
c           counts the level 2 branch and serves as a data integrity
c           check in aML.  _branch2 is in name, but nx is not
c           incremented, because it is used to read in data.
            if(prevlevel.le.1)then
               nvar=nvar+1
               name(nvar)='_branch2'
            endif
            call varlist(numvar,nvar,nx(level,dd),deduct,name,
     *         line,il)
            datalevel(dd)=level
         endif
         prevlevel=level
      elseif(smtxt(4,line,il,'DATA STRUCTURE ='))then
         if(dd.eq.1.and.datastructure(dd).eq.0)goto 820
         dd=dd+1
         call getint(4,datastructure(dd),line,il,status)
         if(status.gt.0)goto 830
c        Data structures must be strictly positive and unique.
         if(datastructure(dd).le.0)goto 830
         call intmatch(datastructure(dd),datastructure,dd-1,match)
         if(match.ne.0)goto 840
         if(.not.smtxt(4,line,il,';'))goto 820
         prevlevel=1
      elseif(smtxt(4,line,il,'VARiables='))then
c        Shortcut in case there is only one level, one data structure:
         if(prevlevel.gt.0)goto 820
         dd=1
         datalevel(dd)=1
         call varlist(numvar,nvar,nx(1,1),deduct,name,line,il)
         if(.not.iseof(4,line,il))goto 820
         goto 300
      else
c        Nothing matched; end of file or syntax error.
         if(iseof(4,line,il))goto 300
         goto 820
      endif
      goto 200
 
  300 close(4)
c     Create pointers namepntr to beginning of variables in oldname
c     and fill out nx.
      next=nx(1,1)+3
      do 310 dim=1,datadim
         nx(1,dim)=nx(1,1)
         namepntr(1,dim)=1
         do 320 level=2,levelmax
            namepntr(level,dim)=next
            if(level.le.datalevel(dim))then
               next=next+nx(level,dim)
c              Variable _branch2 is inserted:
               if(level.eq.2)next=next+1
            endif
  320    continue
  310 continue
 
c     Check that the number of variables read corresponds to the number
c     read by scanr2a:
      if(nvar.ne.numvar)goto 800
c     Check that there are no duplicate names within processes.
      call checknames(datadim,levelmax,nvar,datalevel,nx,
     *   namepntr,datastructure,name)
c     Turn off irrelevance check if none of the structures is rectangular.
      if(intvecmax(rect,datadim).lt.1)irrelcheck=.false.
c     Determine whether any deviations are taken:
      deviations = .not.realallzero(deduct,nvar)
c     Flag double names.  (Legal if they appear in different data structures;
c     illegal and caught in checknames if they appear within the same data
c     structure.)
      do 330 i=nx(1,1)+3,nvar
         call char8match(name(i),name,i-1,match)
         if(match.eq.0)goto 330
         double(i)=match
         double(match)=match
  330 continue
 
c     Cross-data structure statistics are irrelevant if there is only
c     one structure:
      if(datadim.eq.1)cross=.false.
      goto 999
 
  800 call bug(1,1)
  810 call caretline(6,line,il)
      call caretline(8,line,il)
      write(6,811)
      write(8,811)
  811 format('ERROR:  ascii records must always be written at level ',
     *   '2, i.e., your',/,'data management package must write out a ',
     *   'record for every level 2',/,'branch.  This implies that ',
     *   'every record includes one "set" of level 1',/,'variables ',
     *   'and one "set" of level 2 variables (plus multiple sets of',/,
     *   'lower level variables, corresponding the number of lower ',
     *   'level',/,'subbranches.)  There is thus no room for a ',
     *   'specification of the number ',/,'of subbranches at level 1 ',
     *   'or 2.  For details see the manual.')
      stop
  820 call caretline(6,line,il)
      call caretline(8,line,il)
      write(6,821)
      write(8,821)
      call r2asyntax()
  821 format('ERROR:  unexpected statement in control file.')
      stop
  830 call caretline(6,line,il)
      call caretline(8,line,il)
      write(6,831)
      write(8,831)
  831 format('ERROR: positive integer expected.')
      stop
  840 call writeaia(8,72,1,'ERROR:  data structure ',
     *   datastructure(dd),' appears at least twice.')
      call writeaia(6,72,1,'ERROR:  data structure ',
     *   datastructure(dd),' appears at least twice.')
      stop
  850 il=il-1
      call caretline(6,line,il)
      call caretline(8,line,il)
      write(6,851)
      write(8,851)
  851 format('ERROR:  variable lists must be specified in increasing ',
     *   'order of levels.')
      stop
  860 if(rect(dd).ne.1)il=max(1,il-4)
      call caretline(6,line,il)
      call caretline(8,line,il)
      if(rect(dd).ne.1)then
         write(6,861)
         write(8,861)
  861    format(/,'ERROR: your (NB=..) statement indicates that the ',
     *      'raw data are',/,'rectangular.  In that case, you must ',
     *      'specify the number of',/,'subbranches for all variables ',
     *      'lists at level>=3, not just here.',/)
      else
         write(6,862)
         write(8,862)
  862    format(/,'ERROR: expected (NB=..) here.  Note that you need ',
     *      'to specify the',/,'number of subbranches for all ',
     *      'variable lists at level>=3.',/)
      endif
      stop
  999 return
      end
