      subroutine track_stats(iobs,nvar,nb2,levelmax,datadim,nbdim,
     *   datalevel,nblong,nx,namepntr,xpntr,ds,strucfreq,xbase,
     *   xdim,xmean,xstd,xmin,xmax,x,initialized,initial)
 
c     Subroutine to accumulate statistics leading to the computation
c     of mean, standard deviation, minimum and maximum of all variables.
c
c     This routine requires compressed data format.
c
c     Constantijn Panis, 19 July 1999
c     Last change: initialized at each level
 
      implicit none
      integer iobs,nvar,nb2,levelmax,datadim,nbdim,datalevel(datadim),
     *   nblong(nbdim,2),nx(levelmax,datadim),
     *   namepntr(levelmax,datadim),xpntr(2:levelmax,nb2),
     *   ds(nb2),strucfreq(datadim),xbase(nvar),
     *   xdim,level,ib2,i,j,b,numvar,num,dsib,branch(2),dim,nmbrnch
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar),xx
      real x(xdim)
      logical initialized,initial(2:levelmax,datadim)
      data branch/2*1/
 
c     First deal with level 1 variables:
      if(iobs.eq.1)call copy48(x,xmin,2+nx(1,1))
      if(iobs.eq.1)call copy48(x,xmax,2+nx(1,1))
      do 100 i=1,2+nx(1,1)
         xbase(i) = xbase(i) + 1
         xx=dble(x(i))
         xmean(i) = xmean(i) + xx
         xstd(i)  = xstd(i) + xx*xx
         xmin(i)  = min(xmin(i),xx)
         xmax(i)  = max(xmax(i),xx)
  100 continue
 
c     Level 2+:
      do 200 ib2=1,nb2
         dsib=ds(ib2)
         strucfreq(dsib)=strucfreq(dsib)+1
 
c        Are all min/max statistics initialized?
         if(.not.initialized)then
            do 210 level=2,datalevel(dsib)
               if(initial(level,dsib))goto 210
               num=nmbrnch(2,branch,level,nbdim,nblong)
               if(num.eq.0)goto 210
               initial(level,dsib)=.true.
               numvar = nx(level,dsib)
               if(level.eq.2)numvar=numvar+1
               call copy48(x(xpntr(level,ib2)+1),
     *            xmin(namepntr(level,dsib)),numvar)
               call copy48(x(xpntr(level,ib2)+1),
     *            xmax(namepntr(level,dsib)),numvar)
  210       continue
c           Has every data structure, every level been initialized?
            initialized=.true.
            do 220 dim=1,datadim
               do 230 level=2,datalevel(dim)
                  if(.not.initial(level,dim))initialized=.false.
  230          continue
  220       continue
         endif
 
         do 240 level=2,datalevel(dsib)
            branch(2)=ib2
            num=nmbrnch(2,branch,level,nbdim,nblong)
            b = namepntr(level,dsib)-1
            numvar = nx(level,dsib)
            if(level.eq.2)numvar=numvar+1
            do 250 i=1,num
               do 260 j=1,numvar
                  xbase(b+j) = xbase(b+j) + 1
                  xx=dble(x(xpntr(level,ib2)+(i-1)*numvar+j))
                  xmean(b+j) = xmean(b+j) + xx
                  xstd(b+j)  = xstd(b+j) + xx*xx
                  xmin(b+j)  = min(xmin(b+j),xx)
                  xmax(b+j)  = max(xmax(b+j),xx)
  260          continue
  250       continue
  240    continue
  200 continue
 
  999 return
      end
