      subroutine writesys(r2aversion,levelmax,datadim,nobs,nbmax,
     *   xdimmax,nblongdimmax,nvar,structure,datalevel,nx,namepntr,
     *   xmean,xstd,xmin,xmax,deduct,name,date)
 
c     Subroutine to write unformatted data documentation, for other
c     programs to be interpreted.  If cross-means are desired (the
c     default), the summary statistics that are written in this routine
c     will be across data structures.  The rationale is that the mean
c     tends to be used in simulations, and it probably makes more sense
c     to assign the cross-mean to a "mean" specification in such
c     simulations.
c
c     nbmax indicates numbers of subbranches in any one observation.
c
c     Constantijn Panis, 28 August 1997
c     Last change: write to unit 13, appending to the data set.
 
      implicit none
      integer r2aversion,levelmax,datadim,nobs,xdimmax,nblongdimmax,
     *   nvar,structure(datadim),datalevel(datadim),
     *   nbmax(levelmax-1,2:levelmax),
     *   nx(levelmax,datadim),namepntr(levelmax,datadim),dim,i,j,ll
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar)
      real deduct(nvar)
      character name(nvar)*8,date*24
 
      write(13,err=800)date
      write(13,err=800)r2aversion
      write(13,err=800)datadim,nobs,nvar,levelmax,xdimmax,nblongdimmax
      write(13,err=800)((nbmax(i,j),j=2,levelmax),i=1,levelmax-1)
      write(13,err=800)structure
      write(13,err=800)datalevel
      do 100 dim=1,datadim
         nx(1,dim)=nx(1,dim)+2
         if(levelmax.gt.1)nx(2,dim)=nx(2,dim)+1
  100 continue
      write(13,err=800)
     *   ((nx(ll,dim),ll=1,datalevel(dim)),dim=1,datadim),
     *   ((namepntr(ll,dim),ll=1,datalevel(dim)),dim=1,datadim)
      do 200 dim=1,datadim
         nx(1,dim)=nx(1,dim)-2
         if(levelmax.gt.1)nx(2,dim)=nx(2,dim)-1
  200 continue
      write(13,err=800)name,deduct,xmean,xstd,xmin,xmax
      close(13)
      goto 999
 
  800 write(8,801)
      write(6,801)
  801 format(/,'ERROR encountered while writing the output data set.',/,
     *   'Is there sufficient space on the disk?')
  999 return
      end
