      subroutine amlfiles(amlfile,amlversion,line)
 
c     Subroutine to open files for control file and output.
c     Allowable command line options are:
c        -r replace outputfile, if already existing, without warning
c        -o outputfile
c        -m file containing macro-expanded no-comments control file
c     The last argument must be the name or stem of the control file.
c
c     The control file is stripped from comments; macros are expanded.
c
c     Constantijn Panis,  21 January 2006
c     Last change: Remove license issues
 
      implicit none
      integer(2)i
c     integer i
c     integer i
c     integer i
c     integer(2)i
      integer amlversion,warn,status,n,trm,readonly
      integer narg,iargc
c     integer narg,iargc
c     integer narg,iargc
c     integer narg,iargc
c     integer narg,iargc
      logical exist,cmpstri
      character amlfile*128,outfile*128,
     *   macrofile*128,stem*128,line*128,borndate*24
      data borndate/'Mon Jan 23 22:14:28 2006'/
 
      amlfile=' '
      outfile=' '
      macrofile=' '
c     By default, warn before overwriting existing outputfile
      warn=1
 
      narg=iargc()
c     narg=iargc()
c     narg=iargc()
c     narg=iargc()
c     narg=iargc()
 
      if(narg.eq.0)goto 800
      i=0
  100 i=i+1
      call getarg(i,stem)
c     call getarg(i,stem)
c     call getarg(i,stem)
c     call getarg(i,stem)
c     call getarg(i,stem)
      n=trm(stem)
      if(stem.eq.'-h'.or.stem.eq.'-?')then
         goto 800
      elseif(stem.eq.'-borndate')then
         goto 810
      elseif(stem.eq.'-r')then
c        Overwrite outputfile without warning
         warn=0
      elseif(stem.eq.'-o')then
         if(i.ge.narg)goto 800
         i=i+1
         call getarg(i,outfile)
c        call getarg(i,outfile)
c        call getarg(i,outfile)
c        call getarg(i,outfile)
c        call getarg(i,outfile)
      elseif(stem.eq.'-m')then
         if(i.ge.narg)goto 800
         i=i+1
         call getarg(i,macrofile)
c        call getarg(i,macrofile)
c        call getarg(i,macrofile)
c        call getarg(i,macrofile)
c        call getarg(i,macrofile)
      else
c        This has to be the control file name.
         if(amlfile.ne.' ')goto 800
         if(stem(1:1).eq.'-')goto 800
c        First try default extension .aml, then without extension:
         if(exist(stem(1:n)//'.aml'))then
            amlfile=stem(1:n)//'.aml'
         elseif(exist(stem(1:n)))then
            amlfile=stem(1:n)
         else
            goto 820
         endif
      endif
      if(i.lt.narg)goto 100
 
      if(amlfile.eq.' ')goto 800
      if(outfile.eq.' ')then
         n=trm(amlfile)
         if(n.le.3)then
            outfile=amlfile(1:n)//'.out'
         elseif(cmpstri(amlfile(n-3:n),'.aml'))then
            outfile=amlfile(1:n-3)//'out'
         else
            outfile=amlfile(1:n)//'.out'
         endif
      endif
 
c     Strip comments out of control file, expand macros, and connect
c     stripped version to unit 4.
      call metaparse(amlfile,macrofile,4)
 
c     Open output file:
      if(exist(outfile))then
         if(warn.eq.1)call are_you_sure(outfile)
c        Rename existing output file; a new one is opened below.
         call backup(2,outfile)
      endif
      open(8,file=outfile,err=830)
      if(readonly(8).eq.1)goto 850
      goto 999
 
  800 amlversion=amlversion/10
      if(stem.eq.'-h'.or.stem.eq.'-?')write(6,801)amlversion/100.
      write(6,802)
  801 format('This is aML version',f5.2,'.')
  802 format(/,'Usage:  aml [-h] [-r] [-o outfile]',
     *   ' [-m macrofile] file.aml',//,
     *   'where -h shows this help information;',
     *   /,6x,'-r replaces the output file without warning;',
     *   /,6x,'-o specifies the output file (default is file.out);',
     *   /,6x,'-m specifies the macro expansion file; and',
     *   /,6x,'file.aml is the aML control file.')
      stop
  810 if(borndate.eq.'abcdefghijklmnopqrstuvwx')borndate='Unknown'
      write(6,811)(amlversion/10)/100.,borndate
  811 format('aML version',f5.2,/,
     *   'Compile date:  ',a,/,
     *   'Compiler:  Digital Visual Fortran 6.0')
c    *   'Compiler:  SUN Solaris f77 5.0')
c    *   'Compiler:  f77 for Red Hat Linux (version unknown)')
c    *   'Compiler:  Alpha Tru64 UNIX g77 0.5.24')
c    *   'Compiler:  Lahey/Fujitsu Fortran 95 Release 5.60a')
      stop
  820 if(stem(n-3:n).eq.'.aml'.or.stem(n-3:n).eq.'.AML')then
         call not_found(6,stem(1:n))
      else
         call not_found(6,stem(1:n)//'.aml')
      endif
      stop
  830 write(6,'(1x)')
      call wrapstring(6,0,72,0,1,'ERROR opening "'//
     *   outfile(1:trm(outfile))//'"; you probably do not '//
     *   'have write permission or another program is currently '//
     *   'writing to this output file.  Specify command line option '//
     *   '"-o filename" to direct the output elsewhere.')
      stop
  850 call wrapstring(6,0,72,0,1,'ERROR:  the existing '''//
     *   outfile(1:trm(outfile))//''' is read-only.  '//
     *   'Please delete or rename it.')
      stop
  999 return
      end
