      subroutine prepscratch(maxcc,ccmax,dd,rr,ii,ll,cc,levelmax,
     *   nbdimmax,nb,nb2max,nemax,nehmax,nelmax,nepmax,necmax,nebmax,
     *   nenmax,nepomax,nemlmax,nnemlmax,nihmax,nfull,maxmspl,scrdim,
     *   maxnest,numdist,sumdim,sumintdim,xdimmax,vdimmax,maxdraws,nold,
     *   maxmeno,maxnmapmoel,numpar,numrset,maxnode,datadim,maxref,
     *   maxnfreq,maxfreqcat,nummodel,maxxnode,maxpnts,numspl,maxds,
     *   rsh3max,rsh4max,rsh5max,nngammax,rspmax,rsnamax,rsnpmax,
     *   rscmax,rsmlmax,z,wt,originstats,rsetstats,
     *   x,v,xnode,splineorigin,fulltype,iiffull,nested,distdim,
     *   distyp,lamtyp,sparsity,intpnts,intpntr,distpos,moel,nmapmoel,
     *   mapmoel,moelpntr,branch,struc,xpntr,datas,modeltype,mdllvl,
     *   minlnl,nxold,namepntr,datastructure,strctre,dimused,
     *   rsetnum,rsetbegin,parref,rsetref,resref,parpos,
     *   pardim,nfreq,freqloc,freqcat,freqs,strucfreqs,beginspl,
     *   nodepos,numnodes,spltype,splref,draws,draw,cdraw,ndraw,iflam,
     *   oldname,splname,resname,parname,distvar,
     *   numxnode,ifint4,ifint6,allint6,iftau,sumweight,ipt,jpt,
     *   nobs,scrnobs,numarma,wghtpos,useid,useobs,
     *   scrfile,check99999,iid4,detail)
 
c     This subroutine creates the scratch data set and writes it to
c     unit 13.  The original data set is disconnected from unit 12.
c
c     NOTE: the number of observations in the scratch data need not
c     be the same as the number in the original data.  If any
c     episodes enter in the denominator of the likelihood, additional
c     scratch observations are created, resulting in scrnobs observations;
c     the user should never see this; nobs is set to the conceptual
c     number of observations.
c
c     Constantijn Panis, 12 March 2003
c     Last change: z and wt done here
 
      implicit none
c     maxcc is the size of the big scratch array that is set equivalent
c     to dd, rr, ii, ll, and cc.
      integer maxcc,ccmax
      double precision dd(maxcc/8)
      real rr(maxcc/4)
      integer ii(maxcc/4)
      logical ll(maxcc/4)
      character cc(maxcc)*1
 
      integer levelmax,nbdimmax,nb,nb2max,maxnemax,nemax,nehmax,
     *   nelmax,nepmax,necmax,nebmax,nenmax,nepomax,nemlmax,nnemlmax,
     *   nihmax,nfull,maxmspl,scrdim,maxnest,numdist,sumdim,sumintdim,
     *   xdimmax,vdimmax,maxdraws,nold,maxmeno,maxnmapmoel,
     *   numpar,numrset,maxnode,datadim,maxref,maxnfreq,
     *   maxfreqcat,nummodel,maxxnode,maxpnts,
     *   numspl,maxds,rsh3max,rsh4max,rsh5max,nngammax,rspmax,
     *   rsnamax,rsnpmax,rscmax,rsmlmax,allint6
      integer z,wt,originstats,rsetstats,x,v,xnode,splineorigin,
     *   fulltype,iiffull,distdim,distyp,lamtyp,lamrow,sparsity,intpnts,
     *   intpntr,nested,nestpair,distpos,moel,nmapmoel,mapmoel,moelpntr,
     *   branch,prevbranch,struc,xpntr,datas,modeltype,mdllvl,minlnl,
     *   nxold,namepntr,datastructure,strctre,dimused,rsetnum,
     *   rsetbegin,parref,rsetref,resref,parpos,pardim,
     *   nfreq,freqloc,freqcat,freqs,strucfreqs,beginspl,nodepos,
     *   numnodes,spltype,splref,draws,draw,cdraw,ndraw,iflam,
     *   oldname,splname,resname,parname,distvar
      integer ipt,jpt,numxnode,nobs,scrnobs,numarma,wghtpos,useid,
     *   useobs,sumweight,ifint4,ifint6,iftau,iid4,intvecsum
      logical check99999,detail
      character scrfile*128
 
c     Double precision arrays:
      originstats=ccmax/8+2
      rsetstats=originstats+5*numspl
c     Dimension of rsetstats is 5*nfull
      ccmax=8*(rsetstats+5*nfull)
c     Real arrays:
      x=ccmax/4+2
      v=x+xdimmax
      freqcat=v+vdimmax
      sumweight=freqcat+maxfreqcat*maxnfreq
c     Dimension of sumweight is 1
      ccmax=4*(sumweight+1)
 
c     Integer arrays:
      mapmoel=ccmax/4+2
      nb=mapmoel+maxnmapmoel
      branch=nb+nbdimmax*2
      prevbranch=branch+levelmax
      struc=prevbranch+levelmax
c     Note that getdatainfo ensures nb2max>=1
      xpntr=struc+nb2max
      ifint4=xpntr+(levelmax-1)*nb2max
      ifint6=ifint4+numdist
      dimused=ifint6+numdist
c     dimused(sumdim) here; compressed to dimused(sumintdim) far below
c     and used as such in amlfunc.  (Similar for intpnts, intpntr; these
c     are compressed once, in main routine.)
      lamtyp=dimused+sumdim
      lamrow=lamtyp+8*numdist
      nested=lamrow+8*numdist
      nestpair=nested+2*numdist
      freqs=nestpair+numdist*numdist
      strucfreqs=freqs+maxfreqcat*maxnfreq
      draws=strucfreqs+datadim*3
      ndraw=draws+numdist*maxdraws
c     the dimension of ndraw is numdist
      ccmax=4*(ndraw+numdist)
 
c     Logical arrays:
      iflam=ccmax/4+2
      iftau=iflam+numdist
c     The dimension of iftau is 1
      ccmax=4*(iftau+1)
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,nemax,ipt,jpt)
 
c     Need to allocated array cdraw(max(numdist,1),nemax), but at this stage,
c     nemax is unknown.  Since inside prepscratch_, no additional
c     scratch space is allocated, we let cdraw be the last array,
c     without end dimension (other than as implied by maxcc).  This
c     solution is unsatisfactory, but very local:  cdraw is bounded
c     immediately following the call to prepscratch_.
      cdraw=ccmax/4+2
      nemax=0
      maxnemax=(maxcc/4-cdraw)
      if(numdist.gt.0)maxnemax=maxnemax/numdist
 
      call prepscratch_(levelmax,nbdimmax,ii(nb),nb2max,maxnemax,nemax,
     *   nehmax,nelmax,nepmax,necmax,nebmax,nenmax,nepomax,nemlmax,
     *   nnemlmax,nihmax,nfull,maxmspl,
     *   scrdim,maxnest,numdist,sumdim,sumintdim,xdimmax,vdimmax,
     *   maxdraws,nold,maxmeno,maxnmapmoel,numpar,numrset,maxnode,
     *   datadim,maxref,maxnfreq,maxfreqcat,nummodel,maxxnode,
     *   numspl,maxds,rsh3max,rsh4max,rsh5max,nngammax,rspmax,rsnamax,
     *   rsnpmax,rscmax,rsmlmax,allint6,dd(originstats),dd(rsetstats),
     *   rr(x),rr(v),numxnode,rr(xnode),rr(splineorigin),
     *   rr(sumweight),rr(freqcat),ii(freqs),nobs,scrnobs,wghtpos,ipt,
     *   jpt,ii(distdim),ii(distyp),ii(lamtyp),ii(lamrow),sparsity,
     *   ii(distpos),ii(moel),nmapmoel,ii(mapmoel),ii(moelpntr),
     *   ii(struc),ii(xpntr),ii(datas),ii(branch),ii(prevbranch),
     *   ii(modeltype),ii(mdllvl),ii(minlnl),ii(nxold),ii(namepntr),
     *   rr(datastructure),ii(strctre),ii(intpnts),ii(intpntr),
     *   ii(dimused),ii(rsetnum),ii(rsetbegin),ii(parref),ii(rsetref),
     *   ii(resref),ii(parpos),ii(pardim),ii(nfreq),ii(freqloc),
     *   ii(strucfreqs),useobs,useid,ii(beginspl),ii(nodepos),
     *   ii(numnodes),ii(spltype),ii(splref),ii(draws),ii(cdraw),
     *   ii(ndraw),ii(nested),ii(nestpair),numarma,ii(fulltype),
     *   ii(iiffull),ii(ifint4),ii(ifint6),ll(iflam),ll(iftau),detail,
     *   check99999,scrfile,cc(oldname),cc(splname),cc(resname),
     *   cc(parname),cc(distvar),ll(iid4))
 
c     The dimension of cdraw is nemax; the rest may be released.
      draw=cdraw+nemax
c     The dimension of draw is (numdist,nemax)
      ccmax=4*(draw+numdist*nemax)
 
c     Allocate integration points and weights:
      maxpnts=intvecsum(ii(intpnts),sumdim)
      z=ccmax/8+2
      wt=z+maxpnts
      ccmax=8*(wt+maxpnts)
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,nemax,ipt,jpt)
 
c     Compute integration points and weights:
      call comppoints(maxpnts,sumdim,ii(intpnts),ii(intpntr),
     *   dd(z),dd(wt),ipt,jpt)
 
  999 return
      end
c=======================================================================
      subroutine prepscratch_(levelmax,nbdimmax,nb,nb2max,maxnemax,
     *   nemax,nehmax,nelmax,nepmax,necmax,nebmax,nenmax,nepomax,
     *   nemlmax,nnemlmax,nihmax,nfull,maxmspl,scrdim,maxnest,numdist,
     *   sumdim,sumintdim,xdimmax,vdimmax,maxdraws,nold,maxmeno,
     *   maxnmapmoel,numpar,numrset,maxnode,datadim,maxref,maxnfreq,
     *   maxfreqcat,nummodel,maxxnode,numspl,maxds,rsh3max,rsh4max,
     *   rsh5max,nngammax,rspmax,rsnamax,rsnpmax,rscmax,rsmlmax,
     *   allint6,originstats,rsetstats,x,v,numxnode,
     *   xnode,splineorigin,sumweight,freqcat,freqs,nobs,scrnobs,
     *   wghtpos,ipt,jpt,distdim,distyp,lamtyp,lamrow,sparsity,distpos,
     *   moel,nmapmoel,mapmoel,moelpntr,struc,xpntr,datas,branch,
     *   prevbranch,modeltype,mdllvl,minlnl,nxold,namepntr,
     *   datastructure,strctre,intpnts,intpntr,dimused,rsetnum,
     *   rsetbegin,parref,rsetref,resref,parpos,pardim,nfreq,freqloc,
     *   strucfreqs,useobs,useid,beginspl,nodepos,numnodes,spltype,
     *   splref,draws,draw,ndraw,nested,nestpair,numarma,fulltype,
     *   iiffull,ifint4,ifint6,iflam,iftau,detail,check99999,scrfile,
     *   oldname,splname,resname,parname,distvar,iid4)
 
c     This subroutine creates the scratch data set and writes it to
c     unit 13.  The original data set is disconnected from unit 12.
c
c     NOTE: the number of observations in the scratch data need not
c     be the same as the number in the original data.  If any
c     episodes enter in the denominator of the likelihood, additional
c     scratch observations are created, resulting in scrnobs observations;
c     the user should never see this; nobs is set to the conceptual
c     number of observations.
 
      implicit none
      integer levelmax,nbdimmax,nb(nbdimmax*2),nb2max,nb2,nbdim,
     *   maxnemax,nemax,nehmax,nelmax,nepmax,necmax,nebmax,nenmax,
     *   nepomax,nemlmax,nnemlmax,
     *   nihmax,nfull,maxmspl,scrdim,maxnest,numdist,sumdim,sumintdim,
     *   xdimmax,vdimmax,maxdraws,nold,maxmeno,maxnmapmoel,numpar,
     *   numrset,maxnode,datadim,maxref,maxnfreq,
     *   maxfreqcat,nummodel,maxxnode,
     *   numspl,maxds,rsh3max,rsh4max,rsh5max,nngammax,rspmax,
     *   rsnamax,rsnpmax,rscmax,rsmlmax,numxnode
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdimmax),v(vdimmax),xnode(numxnode),
     *   splineorigin(maxmspl),datastructure(datadim),
     *   obsweight,sumweight,freqcat(maxfreqcat,maxnfreq)
      integer fulltype(nfull),iiffull(nfull),ne,neh,nel,nep,nec,neb,nen,
     *   nepo,neml,nneml,nemp,nnemp,neint,nobs,scrnobs,plusobs,minobs,
     *   dropobs,wghtpos,ipt,jpt,id,iobs,distdim(numdist),
     *   distyp(numdist),
     *   lamtyp(numdist,8),lamrow(numdist,8),sparsity,distpos(numdist),
     *   ifint4(numdist),ifint6(numdist),allint6,xdim,vdim,dimscr,
     *   vpntr1,vpntr4,vpntr6,vpntr5,vpntr7,moel(maxmeno),nmapmoel,
     *   mp1,mp4,mp6,mp5,mp7,mapmoel(maxnmapmoel),moelpntr(nummodel),
     *   struc(nb2max),xpntr(2:levelmax,nb2max),datas(nummodel),
     *   branch(levelmax),prevbranch(levelmax),modeltype(nummodel),
     *   mdllvl(nummodel),minlnl(nummodel),nxold(levelmax,datadim),
     *   namepntr(levelmax,datadim),strctre(nummodel),
     *   plusmin,intpnts(sumdim),intpntr(sumdim),dimused(sumdim),
     *   rsetnum(numrset),rsetbegin(numrset),
     *   parref(maxref),rsetref(maxref),resref(maxref),
     *   parpos(numpar),pardim(numpar),nfreq(nummodel),
     *   freqloc(maxnfreq),freqs(maxfreqcat,maxnfreq),
     *   strucfreqs(datadim,3),useobs,useid,trm
      integer beginspl(numspl),nodepos(numspl),numnodes(numspl),
     *   spltype(numspl),splref(maxref),draws(maxdraws,numdist),
     *   draw(numdist,maxnemax),ndraw(numdist),nested(numdist,2),
     *   nestpair(numdist,numdist),numnest,numarma,status,m,num,pos,
     *   meno,countint
      logical iflam(numdist),iftau,detail,check99999,iid4
      character oldname(nold)*8,splname(numspl)*12,parname(numpar)*12,
     *   scrfile*128,resname(sumdim)*8,distvar(numdist)*8
      data plusobs,minobs,dropobs/3*0/
 
c     The data set was opened and rewound by getdatainfo.
c     Open the scratch file.
      if(scrfile.eq.' ')then
         open(13,form='unformatted',status='scratch',err=820)
      else
c        Named scratch data, not removed upon completion of the program.
c        User will need to remove manually.
         open(13,file=scrfile,form='unformatted',err=820)
      endif
 
c     Initialize whether thresholds need to be estimated (changed in
c     figure_tau):
      iftau=.false.
 
c     Maximum number of gammas involved in the baseline survivor function
c     of any one hazard outcome:
      nngammax=0
 
c     Maximum number of nested integrals.  Initialize to one to ensure
c     sufficient space in case there is no integration. It is also
c     crucial to ensure sufficient space for dxblp, dxbc and perhaps
c     more, which need double space in subroutine prepall:
c     dxblp(nel+nep,0:1) and dxbc(nec,0:1).
      maxnest=1
 
c     Figure_pos in amlfunc allocates scratch storage space for
c     various arrays.  Keep track of the largest dimension needed.
      scrdim=0
 
      if(detail)then
c        Initialize encountered values of variables of which frequency
c        tables need to be produced (reference variables; dimensions of
c        integrated distribution) to -99999.
c        (See subroutine figure_freq for the use of -99999.)
         call putreal(-99999.,freqcat,maxfreqcat*maxnfreq)
 
c        Subroutines figdata? accumulate summary statistics on outcome
c        variables.  The hazard and continuous ones are mean/stddev/min/max,
c        not frequency tables.  Same for the continuous element of Tobit
c        models.  Flag their freqs so that they'll always be summary statistics:
         do 100 m=1,nummodel
            if(modeltype(m).ne.1.and.modeltype(m).ne.6.and.
     *         modeltype(m).ne.46)goto 100
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
            if(modeltype(m).eq.1)then
               if(num.lt.4)goto 100
               freqs(1,pos)=-1
               freqs(1,pos+1)=-1
               freqs(1,pos+2)=-1
               freqs(1,pos+3)=-1
            elseif(modeltype(m).eq.6)then
               if(num.lt.1)goto 100
               freqs(1,pos)=-1
            elseif(modeltype(m).eq.46)then
               if(num.lt.2)goto 100
c              Determine whether tobit is left/right/both censored and
c              initialize outcome type frequency categories accordingly
c              (See figure_freq for value labels.)
               meno=moelpntr(m)+2
               if(moel(meno).eq.1)then
                  freqcat(1,pos)=1.
                  freqcat(2,pos)=2.
                  freqcat(3,pos)=3.
                  meno=meno+2
               endif
               if(moel(meno).eq.2)then
                  if(freqcat(1,pos).eq.1.)then
                     freqcat(4,pos)=4.
                     freqcat(5,pos)=5.
                  else
                     freqcat(1,pos)=3.
                     freqcat(2,pos)=4.
                     freqcat(3,pos)=5.
                  endif
               endif
c              Collect summary statistics of noncensored outcomes:
               freqs(1,pos+1)=-1
            endif
  100    continue
      endif
 
      do 200 iobs=1,nobs
 
         read(12,end=810,err=810)id,nb2,nbdim,xdim
         call read_data(levelmax,nb2,nbdim,xdim,struc,nb,xpntr,x,status)
         if(status.ne.0)goto 810
 
c        For debug purposes: if useobs!=0, only useobs is used.
         if(useobs.ne.0)then
            if(iobs.gt.useobs)goto 300
            if(iobs.ne.useobs)goto 200
         endif
c        For debug purposes: if useid!=0, only useid or <=useid is used.
         if(useid.ne.0)then
            if(useid.gt.0.and.id.ne.useid)goto 200
            if(useid.lt.0.and.id.gt.-useid)goto 200
         endif
 
c        Check that data are not corrupt:
         if(levelmax.gt.1)call check_data(levelmax,nb2,xpntr,xdim,
     *      x,ipt,jpt)
 
c        Compute the weight, if any:
         call weighted(wghtpos,xdim,x,obsweight)
 
c        Figure out which model specifications each episode follows:
         plusmin=0
  210    call figure_model(levelmax,nb2,nemax,nehmax,nelmax,nepmax,
     *      necmax,nebmax,nenmax,nepomax,nemlmax,nnemlmax,ne,neh,nel,
     *      nep,nec,neb,nen,nepo,neml,nneml,nemp,nnemp,nihmax,
     *      nold,nbdim,nb,struc,nummodel,datadim,maxmeno,datas,
     *      modeltype,moelpntr,moel,datastructure,xpntr,nxold,namepntr,
     *      branch,strctre,mdllvl,strucfreqs,maxxnode,minlnl,plusmin,
     *      plusobs,minobs,dropobs,xdim,x,xnode,obsweight,sumweight,
     *      oldname,ipt,jpt,iobs,id,status)
 
         if(status.eq.-1)then
c           None of the episodes were modeled:
            status=0
            goto 200
         endif
c        The following checks for space in draw(numdist,nemax); the
c        appropriate error message is written out immediately following
c        prepscratch_.
         if(nemax.gt.maxnemax)goto 999
 
c        Figure out the scratch data vector:
         call figure_data(levelmax,nb2,nbdim,nb,ne,neh,nel,nep,nec,neb,
     *      nen,nepo,neml,nemp,nnemp,neint,numdist,sumdim,distdim,
     *      intpnts,dimused,maxdraws,draws,draw,ndraw,distyp,lamtyp,
     *      lamrow,sparsity,distpos,datadim,vdimmax,maxnfreq,nummodel,
     *      maxmeno,maxnmapmoel,nmapmoel,plusmin,mp1,mp4,mp6,mp5,mp7,
     *      numrset,numpar,maxref,maxfreqcat,maxxnode,xdim,vdim,vpntr1,
     *      vpntr4,vpntr6,vpntr5,vpntr7,struc,xpntr,moel,mdllvl,
     *      moelpntr,mapmoel,datas,minlnl,strctre,namepntr,nxold,nold,
     *      modeltype,rsetbegin,rsetnum,parref,rsetref,resref,parpos,
     *      pardim,nfreq,freqloc,freqcat,freqs,branch,prevbranch,iobs,
     *      id,ipt,jpt,originstats,rsetstats,x,v,xnode,splname,
     *      oldname,resname,parname,distvar,nfull,fulltype,iiffull,
     *      iflam,detail,check99999,ifint4,ifint6,numspl,
     *      maxmspl,splref,beginspl,nodepos,numnodes,spltype,maxnode,
     *      maxds,nngammax,rsh3max,rsh4max,rsh5max,splineorigin,rspmax,
     *      iftau,numarma,rscmax,rsnamax,rsnpmax,rsmlmax)
 
c        How are the outcomes' integrated residuals nested?  Also set
c        all draw(i,ie)=0 for non-integrated distributions.
         call fignest(numdist,ne,ndraw,draw,nested,nestpair,lamtyp,
     *      numnest,neh,nel,nep,nec,neb,nen,nepo,neml,ipt,jpt,iobs,id)
c        Ensure sufficient space for dxblp(nel+nep,0:1) and
c        dxbc(nec,0:1) in prepall:
         numnest=max(1,numnest)
         maxnest=max(maxnest,numnest)
 
c        Check that non-integrated probit residuals are not correlated with
c        other outcome types except continuous outcomes.  If they are
c        correlated with continuous outcomes, none of the residuals in
c        continuous models maybe integrated-out.
         call checkint4(numdist,nested,ifint4,ifint6,ipt,jpt)
 
c        Reduce the size of draw(numdist,ne) to draw(ne) and set ndraw(ie)=-1
c        for continuous modules that are not integrated-out.
c        The compressed array is named cdraw in ithobs; here they share space.
         call sizedraw(numdist,ne,draw,draw,ndraw,nested,
     *      neh,nel,nep,nec)
 
c        Compute dimensions of scr, and make sure that sufficient space
c        will be allocated.
         call checkdims(ne,neh,nel,nep,nec,neb,nen,nepo,neml,nneml,
     *      numdist,numnest,nested,distdim,distyp,lamtyp,ndraw,iid4,
     *      scrdim,dimscr)
 
c        Compress lamtyp(numdist,8) into lamtyp(numdist):
         call codelamtyp(1,numdist,lamtyp)
c        Compress dimused to only refer to integrated distributions:
         call compint(sumdim,intpnts,dimused)
c        Compute sumintdim (sum of dimensions of distributions that are
c        ever integrated-out):
         sumintdim=sumdim-countint(0,intpnts,sumdim)
 
c        Write out scratch data:
         call write_scr(id,numdist,sumintdim,ne,neh,nel,nep,nec,neb,nen,
     *      nepo,neml,nneml,neint,vpntr1,vpntr4,vpntr6,vpntr5,vpntr7,
     *      vdim,mp1,mp4,mp6,mp5,mp7,
     *      nmapmoel,dimscr,plusmin,mapmoel,nested,draw,ndraw,dimused,
     *      lamtyp,obsweight,v,ipt,jpt)
 
c        If there are denominator-episodes, create denominator "observation":
         if(plusmin.eq.1)goto 210
 
  200 continue
 
  300 close(12)
      rewind(13)
 
c     Check that integrated distributions are either all or none
c     integrated out of continuous modules.  Assign conclusion to
c     allint6.
      call checkint6(allint6,numdist,sumdim,ifint6,distdim,intpnts,
     *   ipt,jpt)
 
c     Conceptual number of observations:
      nobs=nobs-dropobs
c     Some observations have been duplicated for the denominator; others
c     were dropped.  Compute the number of "observations" in the scratch data.
      scrnobs=plusobs+minobs
      if(scrnobs.eq.0)goto 830
 
Cc     The code below is irrelevant because figure_res only allows special
Cc     structures for non-integrated distribution.
Cc     Would be very good to incorporate the warning some way into figure_res.
Cc     Integrated distributions are best identified off repeated outcomes
Cc     of the same or other model types.  (The latter is rare.)  If a user
Cc     tries estimation using independent draws, issue a warning.  Also
Cc     re-set lamtyp from 1 (identity) or 4 (sparse) to 0 (generic), i.e.,
Cc     don't try gaining efficiency.
Cc     BUG: checkdim assumed small Lambdas, may not allocate enough space.
C      do 400 i=1,numdist
C         if(lamtyp(i,1).eq.4)lamtyp(i,1)=0
C         if(lamtyp(i,1).eq.1)then
C            lamtyp(i,1)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in hazard models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nehmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'hazard spell'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'hazard spell'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'hazard spell','hazard spell'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'hazard spell','hazard spell'
C               endif
C            endif
C         endif
C         if(lamtyp(i,2).eq.4)lamtyp(i,2)=0
C         if(lamtyp(i,2).eq.1)then
C            lamtyp(i,2)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in logit models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nelmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'logit outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'logit outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'logit outcome','logit outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'logit outcome','logit outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,3).eq.4.and.ifint4(i).eq.1)lamtyp(i,3)=0
C         if(lamtyp(i,3).eq.1.and.ifint4(i).eq.1)then
C            lamtyp(i,3)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in probit models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nepmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'probit outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'probit outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'probit outcome','probit outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'probit outcome','probit outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,4).eq.4.and.ifint6(i).eq.1)lamtyp(i,4)=0
C         if(lamtyp(i,4).eq.1.and.ifint6(i).eq.1)then
C            lamtyp(i,4)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in continuous models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(necmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'continuous outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'continuous outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'continuous outcome','continuous outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'continuous outcome','continuous outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,5).eq.4)lamtyp(i,5)=0
C         if(lamtyp(i,5).eq.1)then
C            lamtyp(i,5)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in binomial models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nebmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'binomial outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'binomial outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'binomial outcome','binomial outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'binomial outcome','binomial outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,6).eq.4)lamtyp(i,6)=0
C         if(lamtyp(i,6).eq.1)then
C            lamtyp(i,6)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in negative binomial models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nebmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'negative binomial outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'negative binomial outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'negative binomial outcome',
C     *               'negative binomial outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'negative binomial outcome',
C     *               'negative binomial outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,7).eq.4)lamtyp(i,7)=0
C         if(lamtyp(i,7).eq.1)then
C            lamtyp(i,7)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in Poisson models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nepomax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'Poisson outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'Poisson outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'Poisson outcome','Poisson outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'Poisson outcome','Poisson outcome'
C               endif
C            endif
C         endif
C         if(lamtyp(i,8).eq.4)lamtyp(i,8)=0
C         if(lamtyp(i,8).eq.1)then
C            lamtyp(i,8)=0
C            if(iiffull(distpos(i)).ne.0.and.
C     *         countintrow(-1,lamtyp(i,1),numdist,8).eq.7)then
Cc              Distribution only appears in multinomial logit models
C               string=resname(intvecsum(distdim,numdist-1)+1)
C               if(nemlmax.eq.1)then
C                  if(ipt.gt.0)write(8,401)string(1:trm(string)),
C     *               'multinomial logit outcome'
C                  if(jpt.gt.0)write(6,401)string(1:trm(string)),
C     *               'multinomial logit outcome'
C               else
C                  if(ipt.gt.0)write(8,402)string(1:trm(string)),
C     *               'multinomial logit outcome',
C     *               'multinomial logit outcome'
C                  if(jpt.gt.0)write(6,402)string(1:trm(string)),
C     *               'multinomial logit outcome',
C     *               'multinomial logit outcome'
C               endif
C            endif
C         endif
C  400 continue
C  401 format(/,'WARNING:  Residual ''',a,''' enters in only one ',a,
C     *   ' per',/,'observation.  Identification of its ',
C     *   'standard deviation is therefore',/,'weak; you may find it ',
C     *   'drifting toward zero and/or cause numerical',/,'underflows.')
C  402 format(/,'WARNING:  While residual ''',a,''' enters in multiple ',
C     *   a,'s per',/,'observation, its entries are independent (with ',
C     *   'new draws).',/,'Identification of its standard deviation is ',
C     *   'therefore weak; you may find',/,'it drifting toward zero ',
C     *   'and/or cause numerical underflows.  Consider',/,'changing ',
C     *   'the "draw" specification such that the residual is ',
C     *   'correlated',/,'across ',a,'s.')
 
      goto 999
 
  810 if(ipt.gt.0)call writeaia(8,72,1,'ERROR in reading the data '//
     *   'set at observation ',iobs,'.')
      if(jpt.gt.0)call writeaia(6,72,1,'ERROR in reading the data '//
     *   'set at observation ',iobs,'.')
      stop
  820 if(scrfile.eq.' ')then
         if(ipt.gt.0)write(8,821)
         if(jpt.gt.0)write(6,821)
  821    format(/,'ERROR opening a scratch file in the current ',
     *      'working directory.  You',/,'probably do not have write ',
     *      'permission.  Note: use "option scratchdsn"',/,'to change ',
     *      'the directory in which aML creates its scratch data set.')
      else
         if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR opening '//
     *      'scratch file '''//scrfile(1:trm(scrfile))//
     *      '''.  You probably do not have write permission.')
         if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR opening '//
     *      'scratch file '''//scrfile(1:trm(scrfile))//
     *      '''.  You probably do not have write permission.')
      endif
      stop
  830 if(ipt.gt.0)write(8,831)
      if(jpt.gt.0)write(6,831)
  831 format(/,'ERROR:  no observations.')
  899 stop
  999 return
      end
